#include    <stdio.h>
#include    <stdlib.h>
#include	<dos.h>
#include    <conio.h>

#include    "stdtype.h"
#include    "config.h"
#include	"dsp.h"
#include	"mixer.h"
#include	"es6xx.h"
#include	"screenio.h"
#include	"display.h"
#include	"play.h"
#include	"main.h"
#include	"pciio.h"
#include	"io32bit.h"
#include    "1938.h"

#define PCI_DEV_ID  0x125D
#define PCI_VEN_ID  0x1969

extern  WORD    gwDevFuncNum;



/*****************************************************************************/
/* vClrDMAChannel - Enable DMA Channel                                       */
/*                                                                           */
/*****************************************************************************/
void    vMskDMAChannel( BYTE _bDSPChannel )
    {
    WORD    wBaseIO = gwIODMA[_bDSPChannel];

    switch( _bDSPChannel )
        {
        case _ES_CHANNEL0:
            outp( wBaseIO + 0x0F, BSETBIT( inp( wBaseIO + 0x0F ), 0 ) );
            break;

        case _ES_CHANNEL1:
            outp( wBaseIO + 0x06, BMSKBIT( inp( wBaseIO + 0x06 ), 1 ) );
            break;

        default:
            break;
        }
    }

/*****************************************************************************/
/* vMskDMAChannel - Disable DMA Channel for programming                      */
/*                                                                           */
/*****************************************************************************/
void    vClrDMAChannel( BYTE _bDSPChannel )
    {
    WORD    wBaseIO = gwIODMA[_bDSPChannel];

    switch( _bDSPChannel )
        {
        case _ES_CHANNEL0:
            outp( wBaseIO + 0x0F, BMSKBIT( inp( wBaseIO + 0x0F ), 0 ) );
            break;

        case _ES_CHANNEL1:
            outp( wBaseIO + 0x06, BSETBIT( inp( wBaseIO + 0x06 ), 1 ) );
            break;

        default:
            break;
        }
    }


/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vSetDMATransfer( BYTE _bDSPChannel, LPBYTE _lpBufferPtr, WORD _wBufferSize, BYTE _bModeFlags )
    {
    WORD    wBaseIO = gwIODMA[_bDSPChannel];
	
    WORD    wTmpSeg,
            wTmpOff;

    wTmpSeg = (WORD)_FP_SEG( _lpBufferPtr );
	wTmpOff = (WORD)_FP_OFF( _lpBufferPtr );
	
	wTmpOff += ( wTmpSeg << 4 );
	
//    if( _bDMAChannel > 4 )
//        {
//        wTmpOff = wTmpOff >> 1;
//        }
		
	wTmpOff &= 0x0FFFFL;

    vMskDMAChannel( _bDSPChannel );

    outpw( wBaseIO + 0x00, wTmpOff );
    outpw( wBaseIO + 0x02, HIBYTE( HIWORD( (DWORD)_lpBufferPtr ) ) >> 4 );


    switch( _bDSPChannel )
        {
        case _ES_CHANNEL0:
            outpw( wBaseIO + 0x04, _wBufferSize - 1 );
            outp( wBaseIO + 0x0B, _bModeFlags );
            break;

        case _ES_CHANNEL1:
            outpw( wBaseIO + 0x04, _wBufferSize );
            if( _bModeFlags & 0x10 )
                outp( wBaseIO + 0x06, BSETBIT( inp( wBaseIO + 0x06 ), 3 ) );
            break;

        default:
            break;
        }

    vClrDMAChannel( _bDSPChannel );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
LPBYTE  lpGetDMAAddress( BYTE _bDSPChannel, LPBYTE *_lpBufferPtr )
	{
    WORD    wBaseIO = gwIODMA[_bDSPChannel];

    switch( _bDSPChannel )
        {
        case _ES_CHANNEL0:
            *_lpBufferPtr = (LPBYTE)MAKELONG( inpw( wBaseIO + 0x00 ), (WORD)inp( wBaseIO + 0x02 ) );
            break;

        case _ES_CHANNEL1:
            *_lpBufferPtr = (LPBYTE)MAKELONG( inpw( wBaseIO + 0x00 ), inpw( wBaseIO + 0x02 ) );
            break;
        }

    return( *_lpBufferPtr );
	}

	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vSetInputVolume( BYTE _bLVolume, BYTE _bRVolume )
	{
	iWrXReg( 0xB4, (BYTE)( ( _bLVolume << 4 ) | _bRVolume ) );
	}
		
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vConfigureAudioDrive( void )
	{
    gwIODMA[ _ES_CHANNEL0 ] = gwIOPCI + 0xF0;
    gwIODMA[ _ES_CHANNEL1 ] = gwIOPCI;

    gwDevFuncNum = iFindPCIDevice( PCI_VEN_ID, PCI_DEV_ID );
	
    iSetPCIInterruptRouting( gwDevFuncNum, 0x0A, gbIRQAudio );

    vWrConfWord( gwDevFuncNum, 0x10, gwIOPCI );
    vWrConfWord( gwDevFuncNum, 0x14, gwIOAudio );
    vWrConfWord( gwDevFuncNum, 0x18, gwIOFMSynth );
    vWrConfWord( gwDevFuncNum, 0x1C, gwIOMPU401 );
    vWrConfWord( gwDevFuncNum, 0x20, gwIOJoystick );
    vWrConfByte( gwDevFuncNum, 0x3C, gbIRQAudio );

    vWrConfByte( gwDevFuncNum, 0x3D, 0x01 );            /* Interrupt Pin 01=INTA */

    vWrConfWord( gwDevFuncNum, 0x60, gwIODMA[0] | 1 );  /* Enable Distributed DMA */
	
    vSetPCIRegBit( 0x04,  2 );                          /* Enable BusMastering */
    vSetPCIRegBit( 0x04,  0 );                          /* Enable I/O Address Space */

    /* PCI40h - Legacy Audio Configuration Register */
    vWrPCIReg( 0x40, 0x00000000 );                      /* Clear all bits */

//    vSetPCIRegBit( 0x40, 15 );                          /* Disable Legacy Audio */
    vMskPCIRegBit( 0x40, 15 );                          /* Enable Legacy Audio */

    vMskPCIRegBit( 0x40, 14 );                          /* Disable Serial Point-to-Point IRQ */

    vSetPCIRegBit( 0x40,  5 );                          /* Set IO Address for 16-bit Decode */
    vMskPCIRegBit( 0x40,  4 );                          /* Disable MPU401 IRQ */
    vSetPCIRegBit( 0x40,  3 );                          /* Enable MPU401 I/O */
    vSetPCIRegBit( 0x40,  2 );                          /* Enable Joystick I/O */
    vSetPCIRegBit( 0x40,  1 );                          /* Enable FM Synthesizer I/O */
    vSetPCIRegBit( 0x40,  0 );                          /* Enable Audio Device */
	

    /* PCI50h - Configuration Register */
    vWrPCIReg( 0x50, 0x00000000 );                      /* Clear all bits */

    vSetPCIRegBit( 0x50, 30 );                          /* Disable Power management */

    vMskPCIRegBit( 0x50, 16 );                          /* Disable Serial IRQ */

    vMskPCIRegBit( 0x50, 15 );                          /* Disable SBIRQ Mask */

    vMskPCIRegBit( 0x50, 14 );                          /* Disable PIC Snoop Mode 1 */
    vSetPCIRegBit( 0x50, 13 );                          /* Disable PIC Snoop Mode 0 */

    vMskPCIRegBit( 0x50, 12 );
    vMskPCIRegBit( 0x50, 11 );

    vMskPCIRegBit( 0x50, 10 );                          /* Set PCI DMA Policy to Distributed DMA */
    vMskPCIRegBit( 0x50,  9 );
    vSetPCIRegBit( 0x50,  8 );

    vMskPCIRegBit( 0x50,  7 );                          /* Enable Posted Write */
    vMskPCIRegBit( 0x50,  6 );
    vMskPCIRegBit( 0x50,  5 );

    vMskPCIRegBit( 0x50,  1 );                          /* Disable Subtractive Decode */

    vMskPCIRegBit( 0x50,  0 );                          /* Disable SID/SVID Write */


    /* IOBASE 07h - IRQ Control Register */
    outp( gwIOPCI + 0x07, 0x10 );                       /* Disable All IRQs */

    outp( 0x20, 0x20 );
    outp( 0xA0, 0x20 );

    bWrMReg( 0x7A, 0x00 );


    switch( gwIOAudio )
        {
        case 0x0220:
            vMskPCIRegBit( 0x50, 2 );
            break;

        case 0x0240:
            vSetPCIRegBit( 0x50, 2 );
            break;
        }


    switch( gbIRQAudio )
        {
        case 0x05:
            vMskPCIRegBit( 0x40, 13 );
            vMskPCIRegBit( 0x40, 12 );
            vMskPCIRegBit( 0x40, 11 );

            vMskPCIRegBit( 0x40, 10 );
            vMskPCIRegBit( 0x40,  9 );
            vMskPCIRegBit( 0x40,  8 );
            break;

        case 0x07:
            vMskPCIRegBit( 0x40, 13 );
            vMskPCIRegBit( 0x40, 12 );
            vSetPCIRegBit( 0x40, 11 );

            vMskPCIRegBit( 0x40, 10 );
            vMskPCIRegBit( 0x40,  9 );
            vSetPCIRegBit( 0x40,  8 );
            break;

        case 0x09:
            vMskPCIRegBit( 0x40, 13 );
            vSetPCIRegBit( 0x40, 12 );
            vMskPCIRegBit( 0x40, 11 );

            vMskPCIRegBit( 0x40, 10 );
            vSetPCIRegBit( 0x40,  9 );
            vMskPCIRegBit( 0x40,  8 );
            break;

        case 0x0A:
            vMskPCIRegBit( 0x40, 13 );
            vSetPCIRegBit( 0x40, 12 );
            vSetPCIRegBit( 0x40, 11 );

            vMskPCIRegBit( 0x40, 10 );
            vSetPCIRegBit( 0x40,  9 );
            vSetPCIRegBit( 0x40,  8 );
            break;

        case 0x0B:
            vSetPCIRegBit( 0x40, 13 );
            vMskPCIRegBit( 0x40, 12 );
            vMskPCIRegBit( 0x40, 11 );

            vSetPCIRegBit( 0x40, 10 );
            vSetPCIRegBit( 0x40,  9 );
            vMskPCIRegBit( 0x40,  8 );
            break;
        }

    switch( gwIOMPU401 )
        {
        case 0x0300:
            vMskPCIRegBit( 0x50,  4 );
            vSetPCIRegBit( 0x50,  3 );
            break;

        case 0x0320:
            vSetPCIRegBit( 0x50,  4 );
            vMskPCIRegBit( 0x50,  3 );
            break;

        case 0x0330:
            vMskPCIRegBit( 0x50,  4 );
            vMskPCIRegBit( 0x50,  3 );
            break;

        case 0x0340:
            vSetPCIRegBit( 0x50,  4 );
            vSetPCIRegBit( 0x50,  3 );
            break;
        }

    if( iResetFIFO() != _ES_DSP_RESET_OK )
        {
        printf("ESS %s AudioDrive not detected\n", _CHIPNAME );
        exit( 0 );
        }

	bWrMReg( 0x71, 0x16 );
    bWrMReg( 0x7A, 0x00 );
    bMskMRegBit( 0x7D, 3 );


    vInitMixer();
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vInitMixer( void )
    {
    vResetMixer();
	
	bMskMRegBit( 0x50, 3 );	/* Disable Spatializer */

    bWrMReg( _MREG_PM_MASTERL_VOLUME,	gbMasterVolumeL );
    bWrMReg( _MREG_PM_MASTERR_VOLUME,	gbMasterVolumeR	);
    
    iWrXReg( _XREG_RM_WAVEIN_VOLUME,    (BYTE)( ( gbWaveInVolumeL << 4 ) | gbWaveInVolumeR ) );
	
    bWrMReg( _MREG_PM_WAVE_VOLUME,		0x00 );
    bWrMReg( _MREG_PM_ALTDAC_VOLUME,    (BYTE)( ( gbWaveOutVolumeL << 4 ) | gbWaveOutVolumeR ) );
	bWrMReg( _MREG_PM_MIC_VOLUME,		0x00 );
    bWrMReg( _MREG_PM_FMSYNTH_VOLUME,   (BYTE)( ( gbFMSynthVolumeL << 4 ) | gbFMSynthVolumeR ) );
	bWrMReg( _MREG_PM_CDLINEIN_VOLUME,	0x00 );
	bWrMReg( _MREG_PM_AUXB_VOLUME,		0x00 );
	bWrMReg( _MREG_PM_PCSPK_VOLUME,		0x00 );
	bWrMReg( _MREG_PM_LINEIN_VOLUME,	0x00 );
	
	bWrMReg( _MREG_RM_ALTDAC_VOLUME,	0x00 );
	bWrMReg( _MREG_RM_FMSYNTH_VOLUME,	0x00 );
    bWrMReg( _MREG_RM_MIC_VOLUME,       0x00 );
    bWrMReg( _MREG_RM_CDLINEIN_VOLUME,  0x00 );
    bWrMReg( _MREG_RM_LINEIN_VOLUME,    0x00 );
    bWrMReg( _MREG_RM_MONOIN_VOLUME,    0x00 );
	bWrMReg( _MREG_RM_AUXB_VOLUME,		0x00 );

    vSetRecordSource( _SRC_MIXER ); /* Set recording source to RECORD MIXER */
    }

/*****************************************************************************/
/* iSetDSPSampleRate - Set Playback/Record DSP Samplng Rate                  */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPSampleRate( BYTE _bDSPChannel, WORD _wSampleRate )
	{
	int     iRetVal = _ES_DSP_OK;

	vDisplayDebugMessage( "iSetDSPSampleRate = Channel:%02X SampleRate:%u\n", _bDSPChannel, _wSampleRate );

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
				if( bTstMRegBit( 0x71, 5 ) == FALSE )
					{
					if ( _wSampleRate < 22050 )
						{
						iRetVal = iWrXReg( _ES_DSP_XREG_SMPLRATE, LOBYTE( 128 - ( 397700 / _wSampleRate ) ) );
						}
					else
						{
						iRetVal = iWrXReg( _ES_DSP_XREG_SMPLRATE, LOBYTE( 256 - ( 795500 / _wSampleRate ) ) );
						}
					}
				else
					{
					if ( _wSampleRate < 44100 )
						{
						iRetVal = iWrXReg( _ES_DSP_XREG_SMPLRATE, LOBYTE( 128 - ( 793800 / _wSampleRate ) ) );
						}
					else
						{
						iRetVal = iWrXReg( _ES_DSP_XREG_SMPLRATE, LOBYTE( 256 - ( 768000 / _wSampleRate ) ) );
						}
					}
					break;
		
		case _ES_CHANNEL1:
				if( bTstMRegBit( 0x71, 1 ) == FALSE )
					{
					if( bTstMRegBit( 0x71, 5 ) == FALSE )
						{
						if ( _wSampleRate < 22050 )
							{
							iRetVal = iWrXReg( _ES_DSP_XREG_SMPLRATE, LOBYTE( 128 - ( 397700 / _wSampleRate ) ) );
							}
						else
							{
							iRetVal = iWrXReg( _ES_DSP_XREG_SMPLRATE, LOBYTE( 256 - ( 795500 / _wSampleRate ) ) );
							}
						}
					else
						{
						if ( _wSampleRate < 44100 )
							{
							iRetVal = iWrXReg( _ES_DSP_XREG_SMPLRATE, LOBYTE( 128 - ( 793800 / _wSampleRate ) ) );
							}
						else
							{
							iRetVal = iWrXReg( _ES_DSP_XREG_SMPLRATE, LOBYTE( 256 - ( 768000 / _wSampleRate ) ) );
							}
						}
					}
				else
					{
					if ( _wSampleRate < 44100 )
						{
						bWrMReg( _ES_DSP_MREG_SMPLRATE, LOBYTE( 128 - ( 793800 / _wSampleRate ) ) );
						}
					else
						{
						bWrMReg( _ES_DSP_MREG_SMPLRATE, LOBYTE( 256 - ( 768000 / _wSampleRate ) ) );
						}
					iRetVal = _ES_DSP_OK;
					}
				break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPFilterClock - Set DSP Frequency Filter Clock Rate                  */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPFilterClock( BYTE _bDSPChannel, WORD _wFilterClock )
	{
	int     iRetVal = _ES_DSP_OK;

	vDisplayDebugMessage( "iSetDSPFilterClock = Channel:%02X FilterClock:%u\n", _bDSPChannel, _wFilterClock );

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
            iRetVal = iWrXReg( _ES_DSP_XREG_FCLOCK, LOBYTE( 256 - ( 7160000 / ( ( _wFilterClock / 2 ) * .8 ) ) ) );
			break;

		case _ES_CHANNEL1:
          	bWrMReg( _ES_DSP_MREG_FCLOCK, LOBYTE( 256 - ( 7160000 / ( ( _wFilterClock / 2 ) * .8 ) ) ) );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPIRQControl - Set IRQ Options for DSP                               */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPIRQControl( BYTE _bDSPChannel, BYTE _bIRQFlags )
	{
	int     iRetVal = _ES_DSP_OK;

	vDisplayDebugMessage( "iSetDSPIRQControl = Channel:%02X Flags: %02X\n", _bDSPChannel, _bIRQFlags );

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			iRetVal = iWrXReg( _ES_DSP_XREG_IRQ_CNTL, ( BYTE ) ( ( _bIRQFlags << 2 ) | ( iRdXReg( _ES_DSP_XREG_IRQ_CNTL ) & 0x0F ) ) );
			break;

		case _ES_CHANNEL1:
			iRetVal = iWrXReg( _ES_DSP_XREG_IRQ_CNTL, ( BYTE ) ( ( _bIRQFlags << 2 ) | ( iRdXReg( _ES_DSP_XREG_IRQ_CNTL ) & 0x0F ) ) );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}
		
	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPDRQControl - Set DRQ Options for DSP                               */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPDRQControl( BYTE _bDSPChannel, BYTE _bDRQFlags )
	{
	int     iRetVal = _ES_DSP_OK;

	vDisplayDebugMessage( "iSetDSPDRQControl = Channel:%02X Flags: %02X\n", _bDSPChannel, _bDRQFlags );

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			iRetVal = iWrXReg( _ES_DSP_XREG_DRQ_CNTL, ( BYTE ) ( ( 0x10 | ( _bDRQFlags << 2 ) ) | ( iRdXReg( _ES_DSP_XREG_DRQ_CNTL ) & 0x0F ) ) );
			break;

		case _ES_CHANNEL1:
			iRetVal = iWrXReg( _ES_DSP_XREG_DRQ_CNTL, ( BYTE ) ( ( 0x10 | ( _bDRQFlags << 2 ) ) | ( iRdXReg( _ES_DSP_XREG_DRQ_CNTL ) & 0x0F ) ) );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPTransferSize - Set BufferSize for DSP Transfer                     */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPTransferSize( BYTE _bDSPChannel, WORD _wBufferSize )
	{
	int     iRetVal = _ES_DSP_OK;

	vDisplayDebugMessage( "iSetDSPTransferSize = Channel:%02X Size:%04X\n", _bDSPChannel, _wBufferSize );

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			if( ( iRetVal = iWrXReg( _ES_DSP_XREG_DMA_CNTLO, LOBYTE( 0xFFFF - _wBufferSize ) ) ) != _ES_DSP_ERROR )
				{
				iRetVal = iWrXReg( _ES_DSP_XREG_DMA_CNTHI, HIBYTE( 0xFFFF - _wBufferSize ) );
				}
			break;

		case _ES_CHANNEL1:
			bWrMReg( _ES_DSP_MREG_DMA2_CNTLO, LOBYTE( 0xFFFF - _wBufferSize ) );
			bWrMReg( _ES_DSP_MREG_DMA2_CNTHI, HIBYTE( 0xFFFF - _wBufferSize ) );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPUnsigned - Set dsp for unsigned data                               */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPUnsigned( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			break;

		case _ES_CHANNEL1:
			bMskMRegBit( _ES_DSP_MREG_ADAC_CTRL2, 2 );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}


/*****************************************************************************/
/* iSetDSPSigned - Set dsp for signed data                                   */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPSigned( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			break;

		case _ES_CHANNEL1:
			bSetMRegBit( _ES_DSP_MREG_ADAC_CTRL2, _ES_DSP_ADAC2_FLG_SIGN );
			break;
	
		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSP8BitTransfer                                                       */
/*                                                                           */
/*****************************************************************************/
int     iSetDSP8BitTransfer( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			break;

		case _ES_CHANNEL1:
			bMskMRegBit( _ES_DSP_MREG_ADAC_CTRL1, _ES_DSP_ADAC1_XFERSIZE );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSP8BitTransfer                                                       */
/*                                                                           */
/*****************************************************************************/
int     iSetDSP16BitTransfer( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			break;

		case _ES_CHANNEL1:
			bSetMRegBit( _ES_DSP_MREG_ADAC_CTRL1, _ES_DSP_ADAC1_XFERSIZE );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSP8BitsPerSample - Set dsp for 8bit samples                          */
/*                                                                           */
/*****************************************************************************/
int     iSetDSP8BitsPerSample( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			break;

		case _ES_CHANNEL1:
			bMskMRegBit( _ES_DSP_MREG_ADAC_CTRL2, _ES_DSP_ADAC2_FLG_WORDSIZE );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSP16BitsPerSample - Set dsp for 16bits per sample                    */
/*                                                                           */
/*****************************************************************************/
int     iSetDSP16BitsPerSample( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			break;

		case _ES_CHANNEL1:
			bSetMRegBit( _ES_DSP_MREG_ADAC_CTRL2, _ES_DSP_ADAC2_FLG_WORDSIZE );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPAutoInitMode - Set dsp for autoinitialize transfers                */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPAutoInitMode( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			iRetVal = iSetXRegBit( 0xB8, 2 );
			break;

		case _ES_CHANNEL1:
			bSetMRegBit( _ES_DSP_MREG_ADAC_CTRL1, _ES_DSP_ADAC1_AUTOINIT );
			break;

		default:
			break;
			}
	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPAutoInitMode - Set dsp for non-autoinitialize transfer mode        */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPNonAutoInitMode( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			iRetVal = iMskXRegBit( 0xB8, 2 );
			break;

		case _ES_CHANNEL1:
			bMskMRegBit( _ES_DSP_MREG_ADAC_CTRL1, _ES_DSP_ADAC1_AUTOINIT );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}
		
	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPSingleMode - set dsp for single mode transfer                      */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPSingleMode( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			iRetVal = iMskXRegBit( _ES_DSP_XREG_DEMAND, 0 );
			break;

		case _ES_CHANNEL1:
			bMskMRegBit( _ES_DSP_MREG_ADAC_CTRL1, _ES_DSP_ADAC1_DEMAND0 );
			bMskMRegBit( _ES_DSP_MREG_ADAC_CTRL1, _ES_DSP_ADAC1_DEMAND1 );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}
		
	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPDemandMode - Set dsp for demand mode transfers                     */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPDemandMode( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			iRetVal = iSetXRegBit( _ES_DSP_XREG_DEMAND, 0 );
			break;

		case _ES_CHANNEL1:
			bSetMRegBit( _ES_DSP_MREG_ADAC_CTRL1, _ES_DSP_ADAC1_DEMAND0 );
			bSetMRegBit( _ES_DSP_MREG_ADAC_CTRL1, _ES_DSP_ADAC1_DEMAND1 );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}
		
	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPMono - Set dsp for single channel output                           */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPMono( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			if( ( iRetVal = iMskXRegBit( _ES_DSP_XREG_STEREO, 0 ) ) != _ES_DSP_ERROR )
				{
				iRetVal = iSetXRegBit( _ES_DSP_XREG_STEREO, 1 );
				}
			break;

		case _ES_CHANNEL1:
			bMskMRegBit( _ES_DSP_MREG_ADAC_CTRL2, _ES_DSP_ADAC2_FLG_STEREO );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iSetDSPStereo - Set dsp for two-channel output                            */
/*                                                                           */
/*****************************************************************************/
int     iSetDSPStereo( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			if( ( iRetVal = iSetXRegBit( _ES_DSP_XREG_STEREO, 0 ) ) != _ES_DSP_ERROR )
				{
				iRetVal = iMskXRegBit( _ES_DSP_XREG_STEREO, 1 );
				}
			break;

		case _ES_CHANNEL1:
			bSetMRegBit( _ES_DSP_MREG_ADAC_CTRL2, _ES_DSP_ADAC2_FLG_STEREO );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}
		
	return ( iRetVal );
	}

/*****************************************************************************/
/* iStartDSPTransfer - Start dsp transfer                                    */
/*                                                                           */
/*****************************************************************************/
int     iStartDSPTransfer( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_ERROR;

	vDisplayDebugMessage( "iStartDSPTransfer = Channel:%02X\n", _bDSPChannel );

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			if ( iSetXRegBit( 0xB8, 0 ) != _ES_DSP_ERROR )
				{
				iRetVal = _ES_DSP_OK;
				}
			break;

		case _ES_CHANNEL1:
            bSetMRegBit( _ES_DSP_MREG_ADAC_CTRL1, 0 );
            bSetMRegBit( _ES_DSP_MREG_ADAC_CTRL1, 1 );
            iRetVal = _ES_DSP_OK;
			break;

		default:
			break;
			}

	return ( iRetVal );
	}

/*****************************************************************************/
/* iStopDSPTransfer - Stop dsp transfer                                      */
/*                                                                           */
/*****************************************************************************/
int     iStopDSPTransfer( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	vDisplayDebugMessage( "iStopDSPTransfer = Channel:%02X\n", _bDSPChannel );

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			iRetVal = iMskXRegBit( 0xB8, 0 );
			break;

		case _ES_CHANNEL1:
			bMskMRegBit( _ES_DSP_MREG_ADAC_CTRL1, 0 );
			bMskMRegBit( _ES_DSP_MREG_ADAC_CTRL1, 1 );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}
		
	return ( iRetVal );
	}

/*****************************************************************************/
/* iPauseDSPTransfer - Pause dsp transfer                                    */
/*                                                                           */
/*****************************************************************************/
int     iPauseDSPTransfer( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	vDisplayDebugMessage( "iPauseDSPTransfer = Channel:%02X\n", _bDSPChannel );

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			iRetVal = iMskXRegBit( 0xB8, 0 );
			break;

		case _ES_CHANNEL1:
			bMskMRegBit( _ES_DSP_MREG_ADAC_CTRL2, 5 );
			iRetVal = _ES_DSP_OK;
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}
		
	return ( iRetVal );
	}

/*****************************************************************************/
/* iResumeDSPTransfer - Resume dsp transfer                                  */
/*                                                                           */
/*****************************************************************************/
int     iResumeDSPTransfer( BYTE _bDSPChannel )
	{
	int     iRetVal = _ES_DSP_OK;

	vDisplayDebugMessage( "iResumeDSPTransfer = Channel:%02X\n", _bDSPChannel );

	switch ( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			iRetVal = iSetXRegBit( 0xB8, 0 );
			break;

		case _ES_CHANNEL1:
			bSetMRegBit( _ES_DSP_MREG_ADAC_CTRL2, 5 );
			break;

		default:
			iRetVal = _ES_DSP_ERROR;
			break;
		}
		
	return ( iRetVal );
	}
 	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE	bSetWaveVolume( BYTE _bDSPChannel, BYTE _bVolume )
	{
	BYTE	bRetVal = FALSE;

	switch( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			bWrMReg( _MREG_PM_WAVE_VOLUME, _bVolume );
			bRetVal = TRUE;
			break;

		case _ES_CHANNEL1:
            bWrMReg( _MREG_PM_ALTDAC_VOLUME, _bVolume );
            bRetVal = TRUE;
            break;
						
		default:
			break;
		}

	return( bRetVal );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE	bGetWaveVolume( BYTE _bDSPChannel )
	{
	BYTE	bRetVal = FALSE;
	
	switch( _bDSPChannel )
		{
		case _ES_CHANNEL0:
			bRetVal = bRdMReg( _MREG_PM_WAVE_VOLUME );
			break;

		case _ES_CHANNEL1:
            bRetVal = bRdMReg( _MREG_PM_ALTDAC_VOLUME );
            break;
						
		default:
			break;
		}

	return( bRetVal );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vSetRecordSource( BYTE _bSource )
	{
	bWrMReg( _MREG_RM_SOURCE, (BYTE)( ( bRdMReg( _MREG_RM_SOURCE ) & 0xF8 ) | _bSource ) );
	}
	

