#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<math.h>
#include	<dos.h>
#include	<conio.h>

#include	"stdtype.h"
#include	"config.h"
#include	"screenio.h"
#include	"display.h"


int     _irq_audio_choices[] = { 2, 3, 5, 7, 9, 10, 11, 12, -1 };

int		_io_pci_choices[] = { 0x4000, 0x4800, 0x6000, 0x6800, 0xF000, 0xF800, 0xFC00, -1 };

int     _io_audio_choices[] = { 0x0220, 0x0240, -1 };

int     _io_fmsynth_choices[] = { 0x0388, 0x038A, 0x038C, 0x038E, -1 };

int     _io_mpu401_choices[] = { 0x0300, 0x0310, 0x0320, 0x0330, -1 };

int     _io_joystick_choices[] =   { 0x0200, 0x0201, 0x0202, 0x0203, 0x0204, 0x0205, 0x0206, 0x0207, -1 };

WORD    gwChipType,
		gwCodecType;

WORD    gwIOPCI,
		gwIODMA[2],
		gwIOAudio,
        gwIOMPU401,
        gwIOFMSynth, 
        gwIOJoystick;

BYTE	gbIRQAudio;				/* Maestro Interrupt */

BYTE	flgAutoMode,
		flgWordSize,
		flgTestMic,
		flgTestLineIn,
		flgTestCDLineIn,
	    flgTestJoystick,
        flgTestMPU401,
        flgTestMonoIn;

BYTE	flgAutoMode = FALSE;

char 	gszLogFileName[_MAX_PATH];

BYTE	gbMonoInTolerance,
		gbMicTolerance,
		gbLineInTolerance,
        gbCDLineInTolerance,
        gbJoystickTolerance;
		
WORD	gwMonoInFrequency,
		gwMicFrequency,
		gwLineInFrequency,
		gwCDLineInFrequency;
				

BYTE	gbMasterVolumeR,
		gbMasterVolumeL,
		gbWaveInVolumeR,
		gbWaveInVolumeL,
		gbWaveOutVolumeR,
		gbWaveOutVolumeL,
		gbMonoInVolumeL,
		gbMonoInVolumeR,
		gbFMSynthVolumeL,
		gbFMSynthVolumeR,
		gbMicVolumeR,
		gbMicVolumeL,
		gbLineInVolumeR,
		gbLineInVolumeL,
		gbCDLineInVolumeR,
		gbCDLineInVolumeL;


/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void vSetConfigDefaults( void )
    {
    gwIOPCI				= DEFAULT_IO_PCI;
    
    gwIOAudio         	= DEFAULT_IO_AUDIO;
    gbIRQAudio        	= DEFAULT_IRQ_AUDIO;

    /* No AdLib Synth on SOLO */
    gwIOFMSynth         = DEFAULT_IO_AUDIO + 0x08;

    gwIOMPU401          = DEFAULT_IO_MPU401;
    gwIOJoystick        = DEFAULT_IO_JOYSTICK;

	gbMonoInTolerance	= DEFAULT_MONOIN_TOLERANCE;
	gbMicTolerance		= DEFAULT_MIC_TOLERANCE;
	gbLineInTolerance	= DEFAULT_LINEIN_TOLERANCE;
	gbCDLineInTolerance	= DEFAULT_CDLINEIN_TOLERANCE;
    gbJoystickTolerance = DEFAULT_JOYSTICK_TOLERANCE;

	gwMonoInFrequency	= DEFAULT_MONOIN_FREQUENCY;
	gwMicFrequency		= DEFAULT_MIC_FREQUENCY;
	gwLineInFrequency	= DEFAULT_LINEIN_FREQUENCY;
	gwCDLineInFrequency	= DEFAULT_CDLINEIN_FREQUENCY;
	
	gbMasterVolumeR		= DEFAULT_MASTER_VOLUME_R;
	gbMasterVolumeL		= DEFAULT_MASTER_VOLUME_L;
	
    gbWaveInVolumeR		= DEFAULT_WAVEIN_VOLUME_R;
    gbWaveInVolumeL		= DEFAULT_WAVEIN_VOLUME_L;
    
    gbWaveOutVolumeR	= DEFAULT_WAVEOUT_VOLUME_R;
    gbWaveOutVolumeL	= DEFAULT_WAVEOUT_VOLUME_L;
		
    gbMonoInVolumeR		= DEFAULT_MONOIN_VOLUME_R;
    gbMonoInVolumeL		= DEFAULT_MONOIN_VOLUME_L;
    
	gbFMSynthVolumeL	= DEFAULT_FMSYNTH_VOLUME_L;
	gbFMSynthVolumeR	= DEFAULT_FMSYNTH_VOLUME_R;
	
	gbMicVolumeR		= DEFAULT_MIC_VOLUME_R;
	gbMicVolumeL		= DEFAULT_MIC_VOLUME_L;
	
	gbLineInVolumeR		= DEFAULT_LINEIN_VOLUME_R;
	gbLineInVolumeL		= DEFAULT_LINEIN_VOLUME_L;
	
	gbCDLineInVolumeR	= DEFAULT_CDLINEIN_VOLUME_R;
	gbCDLineInVolumeL	= DEFAULT_CDLINEIN_VOLUME_L;

	sprintf( gszLogFileName, "%s", DEFAULT_LOG_FILENAME );

	flgTestMic			= ENABLE;
	flgTestLineIn		= ENABLE;
	flgTestCDLineIn		= ENABLE;	
	
    flgTestJoystick		= ENABLE;
    flgTestMPU401		= ENABLE;
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE	bWrConfigFile( const char *_lpConfigFileName )
    {
	BYTE	bRetVal = FALSE;
	
    FILE *fpConfigFile;

    if ( ( fpConfigFile = fopen( _lpConfigFileName, "wb" ) ) != NULL )
    	{
        putw( gwIOPCI,          	fpConfigFile );

        putw( gwIOAudio,            fpConfigFile );
        putw( gbIRQAudio,           fpConfigFile );

        putw( gwIOFMSynth,          fpConfigFile );
        putw( gwIOMPU401,			fpConfigFile );
        putw( gwIOJoystick,			fpConfigFile );

        putw( gbMonoInTolerance,	fpConfigFile );
        putw( gbMicTolerance,		fpConfigFile );
        putw( gbLineInTolerance,	fpConfigFile );
        putw( gbCDLineInTolerance,	fpConfigFile );
        putw( gbJoystickTolerance,  fpConfigFile );
        
    	putw( gwMonoInFrequency,	fpConfigFile );
		putw( gwMicFrequency,		fpConfigFile );
        putw( gwLineInFrequency,	fpConfigFile );
        putw( gwCDLineInFrequency,  fpConfigFile );

        putw( gbMasterVolumeR,		fpConfigFile );
        putw( gbMasterVolumeL,		fpConfigFile );

        putw( gbWaveInVolumeR,		fpConfigFile );
        putw( gbWaveInVolumeL,		fpConfigFile );

        putw( gbWaveOutVolumeR,		fpConfigFile );
        putw( gbWaveOutVolumeL,		fpConfigFile );

        putw( gbMonoInVolumeR,		fpConfigFile );
        putw( gbMonoInVolumeL,		fpConfigFile );

        putw( gbFMSynthVolumeR,		fpConfigFile );
        putw( gbFMSynthVolumeL,		fpConfigFile );

        putw( gbMicVolumeR,			fpConfigFile );
        putw( gbMicVolumeL,			fpConfigFile );

        putw( gbLineInVolumeR,		fpConfigFile );
        putw( gbLineInVolumeL,		fpConfigFile );

        putw( gbCDLineInVolumeR,	fpConfigFile );
        putw( gbCDLineInVolumeL,	fpConfigFile );

        putw( flgTestMonoIn,		fpConfigFile );
        putw( flgTestMic,			fpConfigFile );
        putw( flgTestLineIn,		fpConfigFile );
        putw( flgTestCDLineIn,		fpConfigFile );
        putw( flgTestJoystick,		fpConfigFile );
        putw( flgTestMPU401,		fpConfigFile );

		fputs( gszLogFileName,		fpConfigFile );

        fclose( fpConfigFile );
        bRetVal = TRUE;
        }
	return( bRetVal );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE	bRdConfigFile( const char *_lpConfigFileName )
    {
	BYTE	bRetVal = FALSE;
	
	FILE *fpConfigFile;
	
    if ( ( fpConfigFile = fopen( _lpConfigFileName, "rb" ) ) != NULL )
        {
        gwIOPCI				= (WORD)getw( fpConfigFile );

        gwIOAudio			= (WORD)getw( fpConfigFile );
        gbIRQAudio			= (BYTE)getw( fpConfigFile );

        gwIOFMSynth         = (WORD)getw( fpConfigFile );
        gwIOMPU401			= (WORD)getw( fpConfigFile );
        gwIOJoystick		= (WORD)getw( fpConfigFile );
        
		gbMonoInTolerance	= (BYTE)getw( fpConfigFile );
		gbMicTolerance		= (BYTE)getw( fpConfigFile );
		gbLineInTolerance	= (BYTE)getw( fpConfigFile );
        gbCDLineInTolerance = (BYTE)getw( fpConfigFile );
        gbJoystickTolerance = (BYTE)getw( fpConfigFile );

		gwMonoInFrequency	= (WORD)getw( fpConfigFile );
		gwMicFrequency		= (WORD)getw( fpConfigFile );
		gwLineInFrequency	= (WORD)getw( fpConfigFile );
		gwCDLineInFrequency	= (WORD)getw( fpConfigFile );
		
		gbMasterVolumeR		= (BYTE)getw( fpConfigFile );
		gbMasterVolumeL		= (BYTE)getw( fpConfigFile );
		
		gbWaveInVolumeR		= (BYTE)getw( fpConfigFile );
		gbWaveInVolumeL		= (BYTE)getw( fpConfigFile );

		gbWaveOutVolumeR	= (BYTE)getw( fpConfigFile );
		gbWaveOutVolumeL	= (BYTE)getw( fpConfigFile );

		gbMonoInVolumeR		= (BYTE)getw( fpConfigFile );
		gbMonoInVolumeL		= (BYTE)getw( fpConfigFile );

		gbFMSynthVolumeR	= (BYTE)getw( fpConfigFile );
		gbFMSynthVolumeL	= (BYTE)getw( fpConfigFile );

		gbMicVolumeR		= (BYTE)getw( fpConfigFile );
		gbMicVolumeL		= (BYTE)getw( fpConfigFile );

		gbLineInVolumeR		= (BYTE)getw( fpConfigFile );
		gbLineInVolumeL		= (BYTE)getw( fpConfigFile );

		gbCDLineInVolumeR	= (BYTE)getw( fpConfigFile );
		gbCDLineInVolumeL	= (BYTE)getw( fpConfigFile );
		
		flgTestMonoIn		= (BYTE)getw( fpConfigFile );
        flgTestMic          = (BYTE)getw( fpConfigFile );
        flgTestLineIn       = (BYTE)getw( fpConfigFile );
        flgTestCDLineIn     = (BYTE)getw( fpConfigFile );
        flgTestJoystick     = (BYTE)getw( fpConfigFile );
        flgTestMPU401		= (BYTE)getw( fpConfigFile );

		fgets( gszLogFileName, _MAX_PATH, fpConfigFile );

	    fclose( fpConfigFile );
    	bRetVal = TRUE;
        }
    else
    	{
    	vSetConfigDefaults();
    	vConfigureSetup();
    	bWrConfigFile( _lpConfigFileName );
    	bRetVal = TRUE;
    	}
    return( bRetVal );	
    }


