#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include    <stdarg.h>
#include    <dos.h>
#include	<time.h>

#include	<graph.h>
#include	<conio.h>

#include	"stdtype.h"
#include	"config.h"
#include	"mixer.h"
#include	"dsp.h"
#include	"screenio.h"
#include	"display.h"

enum	VOLUMECONTROLS	{
	_MASTER_VOLUME, 
	_WAVEIN_VOLUME,
	_WAVEOUT_VOLUME, 
	_FMSYNTH_VOLUME,
	_MIC_VOLUME, 
	_LINEIN_VOLUME, 
	_CDLINEIN_VOLUME,
	_MONOIN_VOLUME
	};

enum    TOLERANCECONTROLS   {
    _MONOIN_TOLERANCE, _MIC_TOLERANCE, _LINEIN_TOLERANCE, _CDLINEIN_TOLERANCE, _JOYSTICK_TOLERANCE
    };

#define _MAX_VOLUME_CONTROLS    _MONOIN_VOLUME + 1
#define _MAX_TOLERANCE_CONTROLS _JOYSTICK_TOLERANCE + 1
	
#define	_CREG_MASTER_VOLUME		0x02
#define	_CREG_WAVEOUT_VOLUME	0x18
#define	_CREG_WAVEIN_VOLUME		0x1C

#define	_CREG_MIC_VOLUME		0x1E
#define	_CREG_LINEIN_VOLUME		0x10
#define	_CREG_CDLINEIN_VOLUME	0x12

#define	_LEFT					0x00
#define	_RIGHT					0x01

#define	_METER_SIZE				8




                                
float   fVolumeLevels[7][64] =  {
								/* Master Volume Levels */
                                {   -47.25f, -46.50f, -45.75f, -45.00f, -44.25f, -43.50f, -42.75f, -42.00f, -41.25f, -40.50f, -39.75f, -39.00f,  -38.25f, -37.50f, -36.75f, -36.00f,
                                    -35.25f, -34.50f, -33.75f, -33.00f, -32.25f, -31.50f, -30.75f, -30.00f, -29.25f, -28.50f, -27.75f, -27.00f,  -26.25f, -25.50f, -24.75f, -24.00f,
                                    -23.25f, -22.50f, -21.75f, -21.00f, -20.25f, -19.50f, -18.75f, -18.00f, -17.25f, -16.50f, -15.75f, -15.00f,  -14.25f, -13.50f, -12.75f, -12.00f,
                                    -11.25f, -10.50f, - 9.75f, - 9.00f, - 8.25f, - 7.50f, - 6.75f, - 6.00f, - 5.25f, - 4.50f, - 3.75f, - 3.00f,  - 2.25f, - 1.50f, -  .75f,   0.00f  },

                                /* Record Gain Table for Microphone */
								{	  0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,  12.0f,  13.5f,  15.0f,  16.5f,  18.0f,  19.5f,  21.0f,  22.5f,
                                      0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,  12.0f,  13.5f,  15.0f,  16.5f,  18.0f,  19.5f,  21.0f,  22.5f,
                                      0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,  12.0f,  13.5f,  15.0f,  16.5f,  18.0f,  19.5f,  21.0f,  22.5f,
                                      0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,  12.0f,  13.5f,  15.0f,  16.5f,  18.0f,  19.5f,  21.0f,  22.5f  },
														  
								/* Record Gain Table for Other Sources */
								{	- 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,  12.0f,  13.5f,  15.0f,  16.5f,
                                    - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,  12.0f,  13.5f,  15.0f,  16.5f,
                                    - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,  12.0f,  13.5f,  15.0f,  16.5f,
                                    - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,  12.0f,  13.5f,  15.0f,  16.5f  },

                                /* Audio1 Record Volume Levels */
								{	 -1.0f, -30.0f, -27.0f, -24.0f, -21.0f, -18.0f, -15.0f, -12.0f, - 9.0f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,
                                     -1.0f, -30.0f, -27.0f, -24.0f, -21.0f, -18.0f, -15.0f, -12.0f, - 9.0f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,
                                     -1.0f, -30.0f, -27.0f, -24.0f, -21.0f, -18.0f, -15.0f, -12.0f, - 9.0f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,
                                     -1.0f, -30.0f, -27.0f, -24.0f, -21.0f, -18.0f, -15.0f, -12.0f, - 9.0f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f  }, 
													
								/* Audio2 Playback Volume Levels */
								{	 -1.0f, -31.5f, -28.5f, -25.5f, -22.5f, -19.5f, -16.5f, -13.5f, -10.5f, - 9.0f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,
                                     -1.0f, -31.5f, -28.5f, -25.5f, -22.5f, -19.5f, -16.5f, -13.5f, -10.5f, - 9.0f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,
                                     -1.0f, -31.5f, -28.5f, -25.5f, -22.5f, -19.5f, -16.5f, -13.5f, -10.5f, - 9.0f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,
                                     -1.0f, -31.5f, -28.5f, -25.5f, -22.5f, -19.5f, -16.5f, -13.5f, -10.5f, - 9.0f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f  },
													
								/* Mic/Music DAC Volume Levels */
								{	 -1.0f, -21.0f, -18.0f, -15.0f, -12.0f, - 9.0f, - 6.0f, - 3.0f,   0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,
                                     -1.0f, -21.0f, -18.0f, -15.0f, -12.0f, - 9.0f, - 6.0f, - 3.0f,   0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,
                                     -1.0f, -21.0f, -18.0f, -15.0f, -12.0f, - 9.0f, - 6.0f, - 3.0f,   0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f,
                                     -1.0f, -21.0f, -18.0f, -15.0f, -12.0f, - 9.0f, - 6.0f, - 3.0f,   0.0f,   1.5f,   3.0f,   4.5f,   6.0f,   7.5f,   9.0f,  10.5f  },
													
								/* AuxA/AuxB/LineIn/MonoIn Volume Levels */
								{	 -1.0f, -28.5f, -25.5f, -22.5f, -19.5f, -16.5f, -13.5f, -10.5f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,   3.0f,
                                     -1.0f, -28.5f, -25.5f, -22.5f, -19.5f, -16.5f, -13.5f, -10.5f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,   3.0f,
                                     -1.0f, -28.5f, -25.5f, -22.5f, -19.5f, -16.5f, -13.5f, -10.5f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,   3.0f,
                                     -1.0f, -28.5f, -25.5f, -22.5f, -19.5f, -16.5f, -13.5f, -10.5f, - 7.5f, - 6.0f, - 4.5f, - 3.0f, - 1.5f,   0.0f,   1.5f,   3.0f  }
								};
															
/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
void    vDisplayVolume( int x, int y, float _fLevel, BYTE _bMode, BYTE _bLevel )
	{
	char	szTmpStr[80];
	
    if( _bLevel == 0 )
        {
        if( _fLevel == -47.25f )
            {
            sprintf( szTmpStr, " MUTE  " );
            }
        else
            {
            sprintf( szTmpStr, "%5.2f", _fLevel );
            }

        switch( _bMode )
            {
            case _NORMAL:
                vPrintStringXY( x, y, "      dB", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
                vPrintStringXY( x, y, szTmpStr, _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
                break;

            case _HIGHLIGHT:
                vPrintStringXY( x, y, "      dB", _MNU_HIGHLIGHT_FGCOLOR, _MNU_HIGHLIGHT_BGCOLOR  );
                vPrintStringXY( x, y, szTmpStr, _MNU_HIGHLIGHT_FGCOLOR, _MNU_HIGHLIGHT_BGCOLOR );
                break;
            }
        }
    else
        {
        if( _fLevel == -1 )
            {
            sprintf( szTmpStr, " MUTE  " );
            }
        else
            {
            sprintf( szTmpStr, "%5.1f", _fLevel );
            }

        switch( _bMode )
            {
            case _NORMAL:
                vPrintStringXY( x, y, "     dB", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
                vPrintStringXY( x, y, szTmpStr, _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
                break;

            case _HIGHLIGHT:
                vPrintStringXY( x, y, "     dB", _MNU_HIGHLIGHT_FGCOLOR, _MNU_HIGHLIGHT_BGCOLOR  );
                vPrintStringXY( x, y, szTmpStr, _MNU_HIGHLIGHT_FGCOLOR, _MNU_HIGHLIGHT_BGCOLOR );
                break;
            }
        }
	}


/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vDrawSlider( int _iX, int _iY, int _iSize, int _iLevel, BYTE _bBorderType, BYTE _bFGColor, BYTE _bBGColor )
	{
	BYTE	bIndex;
	
	for( bIndex=0; bIndex < _iSize; bIndex++ )
		{
		vPrintCharXY( _iX, (BYTE)(_iY + bIndex), 0xB0, _bFGColor, _bBGColor );
		}

	vPrintCharXY( _iX, (BYTE)(_iY - 1), 0x1E, _bFGColor, _bBGColor );
	vPrintCharXY( _iX, (BYTE)(_iY + _iSize), 0x1F, _bFGColor, _bBGColor );

    vPrintCharXY( _iX, (BYTE)(_iY + _iSize - _iLevel - 1 ), ' ', _bBGColor, _bFGColor );
    }
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vDrawVolumeMeter( int _iX, int _iY, int _iSize, int _iLevel, BYTE _bMode )
	{
	switch( _bMode )
		{
		case _NORMAL:
			vDrawSlider( _iX, _iY, _iSize, _iLevel, _BOX_SINGLE, _MNU_WINDOW_FGCOLOR, _MNU_WINDOW_BGCOLOR );
			break;
			
		case _HIGHLIGHT:
			vDrawSlider( _iX, _iY, _iSize, _iLevel, _BOX_SINGLE, _MNU_HIGHLIGHT_FGCOLOR, _MNU_HIGHLIGHT_BGCOLOR );
			break;	
		}
	}	
	
/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
void	vSetVolumeLevels( void )
	{
	BYTE	bInkey = 0;
	
	static BYTE    bLevel = 0;
	
	BYTE	bIndex;

    char	szTmpStr[80];
	
    BYTE    bSliderMax[ _MAX_VOLUME_CONTROLS ][2] = {   {   0x3F, 0x3F  },
    													{	0x0F, 0x0F	},
    													{	0x0F, 0x0F	},
    													{	0x0F, 0x0F	},
    													{	0x0F, 0x0F	},
    													{	0x0F, 0x0F	},
    													{	0x0F, 0x0F	},
    													{	0x0F, 0x0F	}
    											};
    													
    BYTE    bSliderY[ _MAX_VOLUME_CONTROLS ][2]	=	{	{	0x08, 0x08	},
    													{	0x08, 0x08	},
    													{	0x08, 0x08	},
    													{	0x08, 0x08	},
    													{	0x08, 0x08	},
    													{	0x08, 0x08	},
    													{	0x08, 0x08	},
    													{	0x08, 0x08	}
    												};

    BYTE    bSliderX[ _MAX_VOLUME_CONTROLS ][2]	=  	{	{      4,    5	},
                                                        {     14,   15  },
                                                        {     24,   25  },
                                                        {     34,   35  },
                                                        {     44,   45  },
                                                        {     54,   55  },
                                                        {     64,   65  },
                                                        {     74,   75  }
    												};          
    												
    BYTE    bScale[ _MAX_VOLUME_CONTROLS ][2] =     {   {   0x03, 0x03  },
    													{	0x01, 0x01	},
    													{	0x01, 0x01	},
    													{	0x01, 0x01	},
    													{	0x01, 0x01	},
    													{	0x01, 0x01	},
    													{	0x01, 0x01	},
    													{	0x01, 0x01	}
    												};

	BYTE	bVolumeLevel[_MAX_VOLUME_CONTROLS ][2];
	
	BYTE	bVolumeRegs[ _MAX_VOLUME_CONTROLS ][2];
	
	BYTE	szMeterTitle[ _MAX_VOLUME_CONTROLS ][10];
	
	BYTE	bMeterTable[ _MAX_VOLUME_CONTROLS ];
	
	bMeterTable[ _MASTER_VOLUME ]	= 0;
	bMeterTable[ _WAVEIN_VOLUME ]	= 2;
	bMeterTable[ _WAVEOUT_VOLUME ]	= 4;
	bMeterTable[ _FMSYNTH_VOLUME ]	= 5;
	bMeterTable[ _MIC_VOLUME ]		= 5;
	bMeterTable[ _LINEIN_VOLUME ]	= 6;
	bMeterTable[ _CDLINEIN_VOLUME ]	= 6;
	bMeterTable[ _MONOIN_VOLUME ]	= 6;
	
	strcpy( szMeterTitle[ _MASTER_VOLUME ], "Master" );
	strcpy( szMeterTitle[ _WAVEIN_VOLUME ], "WaveIn" );
	strcpy( szMeterTitle[ _WAVEOUT_VOLUME ], "WaveOut" );
	strcpy( szMeterTitle[ _FMSYNTH_VOLUME ], "Synth" );
	strcpy( szMeterTitle[ _MIC_VOLUME ], "Mic" );
	strcpy( szMeterTitle[ _LINEIN_VOLUME ], "LineIn" );
	strcpy( szMeterTitle[ _CDLINEIN_VOLUME ], "CD" );
	strcpy( szMeterTitle[ _MONOIN_VOLUME ], "MonoIn" );

	bVolumeRegs[ _MASTER_VOLUME ][ _LEFT ]		= _MREG_PM_MASTERL_VOLUME;
	bVolumeRegs[ _MASTER_VOLUME ][ _RIGHT ]		= _MREG_PM_MASTERR_VOLUME;
	
	bVolumeRegs[ _WAVEIN_VOLUME ][ _LEFT ]		= _XREG_RM_WAVEIN_VOLUME;
	bVolumeRegs[ _WAVEIN_VOLUME ][ _RIGHT ]		= _XREG_RM_WAVEIN_VOLUME;

	bVolumeRegs[ _WAVEOUT_VOLUME ][ _LEFT ]		= _MREG_PM_WAVE_VOLUME;
	bVolumeRegs[ _WAVEOUT_VOLUME ][ _RIGHT ]	= _MREG_PM_WAVE_VOLUME;

	bVolumeRegs[ _MONOIN_VOLUME ][ _LEFT ]		= _MREG_RM_MONOIN_VOLUME;
	bVolumeRegs[ _MONOIN_VOLUME ][ _RIGHT ]		= _MREG_RM_MONOIN_VOLUME;

	bVolumeRegs[ _FMSYNTH_VOLUME ][ _LEFT ]		= _MREG_PM_FMSYNTH_VOLUME;
	bVolumeRegs[ _FMSYNTH_VOLUME ][ _RIGHT ]	= _MREG_PM_FMSYNTH_VOLUME;
	
	bVolumeRegs[ _MIC_VOLUME ][ _LEFT ]			= _MREG_PM_FMSYNTH_VOLUME;
	bVolumeRegs[ _MIC_VOLUME ][ _RIGHT ]		= _MREG_PM_FMSYNTH_VOLUME;
	
	bVolumeRegs[ _LINEIN_VOLUME ][ _LEFT ]		= _MREG_PM_FMSYNTH_VOLUME;
	bVolumeRegs[ _LINEIN_VOLUME ][ _RIGHT ]		= _MREG_PM_FMSYNTH_VOLUME;
	
	bVolumeRegs[ _CDLINEIN_VOLUME ][ _LEFT ]	= _MREG_PM_FMSYNTH_VOLUME;
	bVolumeRegs[ _CDLINEIN_VOLUME ][ _RIGHT ]	= _MREG_PM_FMSYNTH_VOLUME;
	

	bVolumeLevel[ _MASTER_VOLUME ][ _LEFT ]		= gbMasterVolumeL;
	bVolumeLevel[ _MASTER_VOLUME ][ _RIGHT ]	= gbMasterVolumeR;
	
	bVolumeLevel[ _WAVEIN_VOLUME ][ _LEFT ]		= gbWaveInVolumeL;
	bVolumeLevel[ _WAVEIN_VOLUME ][ _RIGHT ]	= gbWaveInVolumeR;
	
	bVolumeLevel[ _WAVEOUT_VOLUME ][ _LEFT ]	= gbWaveOutVolumeL;
	bVolumeLevel[ _WAVEOUT_VOLUME ][ _RIGHT ]	= gbWaveOutVolumeR;
	
	bVolumeLevel[ _MONOIN_VOLUME ][ _LEFT ]		= gbMonoInVolumeL;
	bVolumeLevel[ _MONOIN_VOLUME ][ _RIGHT ]	= gbMonoInVolumeR;
	    
    bVolumeLevel[ _FMSYNTH_VOLUME ][ _LEFT ]	= gbFMSynthVolumeL;
    bVolumeLevel[ _FMSYNTH_VOLUME ][ _RIGHT ]	= gbFMSynthVolumeR;

    bVolumeLevel[ _MIC_VOLUME ][ _LEFT ]		= gbMicVolumeL;
    bVolumeLevel[ _MIC_VOLUME ][ _RIGHT ]		= gbMicVolumeR;

    bVolumeLevel[ _LINEIN_VOLUME ][ _LEFT ]		= gbLineInVolumeL;
    bVolumeLevel[ _LINEIN_VOLUME ][ _RIGHT ]	= gbLineInVolumeR;

    bVolumeLevel[ _CDLINEIN_VOLUME ][ _LEFT ]	= gbCDLineInVolumeL;
    bVolumeLevel[ _CDLINEIN_VOLUME ][ _RIGHT ]	= gbCDLineInVolumeR;
    

	vClearScreen();
	vDisplayConfig();
    sprintf( szTmpStr, "Press %c/%c to select, %c/%c/PgUp/PgDn adjust level, esc to return to main menu", 0x1B, 0x1A, 0x18, 0x19 );
    vDisplayOptionMessage( szTmpStr );

	for( bIndex=0; bIndex < _MAX_VOLUME_CONTROLS; bIndex++ )
		{
		vDrawBox( bSliderX[ bIndex ][ _LEFT ] - 1, bSliderY[ bIndex ][ _LEFT ] - 2, bSliderX[ bIndex ][ _RIGHT ] + 1, bSliderY[ bIndex ][ _LEFT ] + _METER_SIZE + 1, _BOX_SINGLE, _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );

		vPrintStringXY( bSliderX[ bIndex ][ _LEFT ] - ( strlen( szMeterTitle[ bIndex ] ) >> 1 ) + 1, bSliderY[ bIndex ][ _LEFT ] - 3, szMeterTitle[ bIndex ], _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );

        vPrintStringXY( bSliderX[ bIndex ][ _LEFT ] - 3, bSliderY[ bIndex ][ _LEFT ] + _METER_SIZE + 2, "L", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
        vPrintStringXY( bSliderX[ bIndex ][ _LEFT ] - 3, bSliderY[ bIndex ][ _LEFT ] + _METER_SIZE + 3, "R", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );

        vDisplayVolume( bSliderX[ bIndex ][ _LEFT ] - 2, bSliderY[ bIndex ][ _LEFT ] + _METER_SIZE + 2, fVolumeLevels[ bMeterTable[ bIndex ] ][ bVolumeLevel[ bIndex ][ _LEFT ] ], _HIGHLIGHT, bLevel );
        vDisplayVolume( bSliderX[ bIndex ][ _LEFT ] - 2, bSliderY[ bIndex ][ _LEFT ] + _METER_SIZE + 3, fVolumeLevels[ bMeterTable[ bIndex ] ][ bVolumeLevel[ bIndex ][ _RIGHT ] ], _HIGHLIGHT, bLevel );
		
		vDrawVolumeMeter( bSliderX[ bIndex ][ _LEFT ], bSliderY[ bIndex ][ _LEFT ], _METER_SIZE, bVolumeLevel[ bIndex ][ _LEFT ] >> bScale[ bIndex ][ _LEFT ], _NORMAL );
		vDrawVolumeMeter( bSliderX[ bIndex ][ _RIGHT ], bSliderY[ bIndex ][ _RIGHT ], _METER_SIZE, bVolumeLevel[ bIndex ][ _RIGHT ] >> bScale[ bIndex ][ _RIGHT ], _NORMAL );
		}

	vDrawBox( bSliderX[ bLevel ][ _LEFT ] - 1, bSliderY[ bLevel ][ _LEFT ] - 2, bSliderX[ bLevel ][ _RIGHT ] + 1, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 1, _BOX_DOUBLE, _MNU_HIGHLIGHT_FGCOLOR, _MNU_HIGHLIGHT_BGCOLOR );

	vDrawVolumeMeter( bSliderX[ bLevel ][ _LEFT ], bSliderY[ bLevel ][ _LEFT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _LEFT ] >> bScale[ bLevel ][ _LEFT ], _HIGHLIGHT );
	vDrawVolumeMeter( bSliderX[ bLevel ][ _RIGHT ], bSliderY[ bLevel ][ _RIGHT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _RIGHT ] >> bScale[ bLevel ][ _RIGHT ], _HIGHLIGHT );
	
    vDisplayVolume( bSliderX[ bLevel ][ _LEFT ] - 2, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 2, fVolumeLevels[ bMeterTable[ bLevel ] ][ bVolumeLevel[ bLevel ][ _LEFT ] ], _HIGHLIGHT, bLevel );
    vDisplayVolume( bSliderX[ bLevel ][ _LEFT ] - 2, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 3, fVolumeLevels[ bMeterTable[ bLevel ] ][ bVolumeLevel[ bLevel ][ _RIGHT ] ], _HIGHLIGHT, bLevel );

	do
		{
		if( kbhit() )
			{
			bInkey = (BYTE)getch();
			switch( bInkey )
				{
				case 0x4B:	/* Left Arrow */
					if( bLevel > 0 )
						{
						vDrawBox( bSliderX[ bLevel ][ _LEFT ] - 1, bSliderY[ bLevel ][ _LEFT ] - 2, bSliderX[ bLevel ][ _RIGHT ] + 1, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 1, _BOX_SINGLE, _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
	                    vDrawVolumeMeter( bSliderX[ bLevel ][ _LEFT ], bSliderY[ bLevel ][ _LEFT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _LEFT ] >> bScale[ bLevel ][ _LEFT ], _NORMAL );
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _RIGHT ], bSliderY[ bLevel ][ _RIGHT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _RIGHT ] >> bScale[ bLevel ][ _RIGHT ], _NORMAL );
						--bLevel;
						vDrawBox( bSliderX[ bLevel ][ _LEFT ] - 1, bSliderY[ bLevel ][ _LEFT ] - 2, bSliderX[ bLevel ][ _RIGHT ] + 1, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 1, _BOX_DOUBLE, _MNU_HIGHLIGHT_FGCOLOR, _MNU_HIGHLIGHT_BGCOLOR );
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _LEFT ], bSliderY[ bLevel ][ _LEFT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _LEFT ] >> bScale[ bLevel ][ _LEFT ], _HIGHLIGHT );
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _RIGHT ], bSliderY[ bLevel ][ _RIGHT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _RIGHT ] >> bScale[ bLevel ][ _RIGHT ], _HIGHLIGHT );
						}
					break;
					
				case 0x4D:	/* Right Arrow */
					if( bLevel < ( _MAX_VOLUME_CONTROLS - 1 ) )
						{
						vDrawBox( bSliderX[ bLevel ][ _LEFT ] - 1, bSliderY[ bLevel ][ _LEFT ] - 2, bSliderX[ bLevel ][ _RIGHT ] + 1, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 1, _BOX_SINGLE, _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _LEFT ], bSliderY[ bLevel ][ _LEFT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _LEFT ] >> bScale[ bLevel ][ _LEFT ], _NORMAL );
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _RIGHT ], bSliderY[ bLevel ][ _RIGHT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _RIGHT ] >> bScale[ bLevel ][ _RIGHT ], _NORMAL );
						++bLevel;
						vDrawBox( bSliderX[ bLevel ][ _LEFT ] - 1, bSliderY[ bLevel ][ _LEFT ] - 2, bSliderX[ bLevel ][ _RIGHT ] + 1, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 1, _BOX_DOUBLE, _MNU_HIGHLIGHT_FGCOLOR, _MNU_HIGHLIGHT_BGCOLOR );
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _LEFT ], bSliderY[ bLevel ][ _LEFT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _LEFT ] >> bScale[ bLevel ][ _LEFT ], _HIGHLIGHT );
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _RIGHT ], bSliderY[ bLevel ][ _RIGHT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _RIGHT ] >> bScale[ bLevel ][ _RIGHT ], _HIGHLIGHT );
						}
					break;
					
				
				case 0x47:	/* Home */
					if( bVolumeLevel[ bLevel ][ _LEFT ] < bSliderMax[ bLevel ][ _LEFT ] )
						{
						++bVolumeLevel[ bLevel ][ _LEFT ];
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _LEFT ], bSliderY[ bLevel ][ _LEFT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _LEFT ] >> bScale[ bLevel ][ _LEFT ], _HIGHLIGHT );
                        vDisplayVolume( bSliderX[ bLevel ][ _LEFT ] - 2, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 2, fVolumeLevels[ bMeterTable[ bLevel ] ][ bVolumeLevel[ bLevel ][ _LEFT ] ], _HIGHLIGHT, bLevel );
                        }
					break;
					
				case 0x4F:	/* End */
					if( bVolumeLevel[ bLevel ][ _LEFT ] > 0 )
						{
						--bVolumeLevel[ bLevel ][ _LEFT ];
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _LEFT ], bSliderY[ bLevel ][ _LEFT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _LEFT ] >> bScale[ bLevel ][ _LEFT ], _HIGHLIGHT );
                        vDisplayVolume( bSliderX[ bLevel ][ _LEFT ] - 2, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 2, fVolumeLevels[ bMeterTable[ bLevel ] ][ bVolumeLevel[ bLevel ][ _LEFT ] ], _HIGHLIGHT, bLevel );
                        }
					break;

				case 0x49:  /* PgUp */	
					if( bVolumeLevel[ bLevel ][ _RIGHT ] < bSliderMax[ bLevel ][ _RIGHT ] )
						{
						++bVolumeLevel[ bLevel ][ _RIGHT ];
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _RIGHT ], bSliderY[ bLevel ][ _RIGHT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _RIGHT ] >> bScale[ bLevel ][ _RIGHT ], _HIGHLIGHT );
                        vDisplayVolume( bSliderX[ bLevel ][ _RIGHT ] - 3, bSliderY[ bLevel ][ _RIGHT ] + _METER_SIZE + 3, fVolumeLevels[ bMeterTable[ bLevel ] ][ bVolumeLevel[ bLevel ][ _RIGHT ] ], _HIGHLIGHT, bLevel );
                        }
					break;

				case 0x51:	/* PgDn */
					if( bVolumeLevel[ bLevel ][ _RIGHT ] > 0 )
						{
						--bVolumeLevel[ bLevel ][ _RIGHT ];
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _RIGHT ], bSliderY[ bLevel ][ _RIGHT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _RIGHT ] >> bScale[ bLevel ][ _RIGHT ], _HIGHLIGHT );
                        vDisplayVolume( bSliderX[ bLevel ][ _RIGHT ] - 3, bSliderY[ bLevel ][ _RIGHT ] + _METER_SIZE + 3, fVolumeLevels[ bMeterTable[ bLevel ] ][ bVolumeLevel[ bLevel ][ _RIGHT ] ], _HIGHLIGHT, bLevel );
                        }
					break;
				

				case 0x48:
					/* Up Arrow */
					if( bVolumeLevel[ bLevel ][ _LEFT ] < bSliderMax[ bLevel ][ _LEFT ] )
						{
						++bVolumeLevel[ bLevel ][ _LEFT ];
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _LEFT ], bSliderY[ bLevel ][ _LEFT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _LEFT ] >> bScale[ bLevel ][ _LEFT ], _HIGHLIGHT );
                        vDisplayVolume( bSliderX[ bLevel ][ _LEFT ] - 2, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 2, fVolumeLevels[ bMeterTable[ bLevel ] ][ bVolumeLevel[ bLevel ][ _LEFT ] ], _HIGHLIGHT, bLevel );
                        }
                        
					if( bVolumeLevel[ bLevel ][ _RIGHT ] < bSliderMax[ bLevel ][ _RIGHT ] )
						{
						++bVolumeLevel[ bLevel ][ _RIGHT ];
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _RIGHT ], bSliderY[ bLevel ][ _RIGHT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _RIGHT ] >> bScale[ bLevel ][ _RIGHT ], _HIGHLIGHT );
                        vDisplayVolume( bSliderX[ bLevel ][ _RIGHT ] - 3, bSliderY[ bLevel ][ _RIGHT ] + _METER_SIZE + 3, fVolumeLevels[ bMeterTable[ bLevel ] ][ bVolumeLevel[ bLevel ][ _RIGHT ] ], _HIGHLIGHT, bLevel );
                        }
					break;
					
				case 0x50:
					/* Down Arrow */
					if( bVolumeLevel[ bLevel ][ _LEFT ] > 0 )
						{
						--bVolumeLevel[ bLevel ][ _LEFT ];
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _LEFT ], bSliderY[ bLevel ][ _LEFT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _LEFT ] >> bScale[ bLevel ][ _LEFT ], _HIGHLIGHT );
                        vDisplayVolume( bSliderX[ bLevel ][ _LEFT ] - 2, bSliderY[ bLevel ][ _LEFT ] + _METER_SIZE + 2, fVolumeLevels[ bMeterTable[ bLevel ] ][ bVolumeLevel[ bLevel ][ _LEFT ] ], _HIGHLIGHT, bLevel );
                        }
					if( bVolumeLevel[ bLevel ][ _RIGHT ] > 0 )
						{
						--bVolumeLevel[ bLevel ][ _RIGHT ];
                        vDrawVolumeMeter( bSliderX[ bLevel ][ _RIGHT ], bSliderY[ bLevel ][ _RIGHT ], _METER_SIZE, bVolumeLevel[ bLevel ][ _RIGHT ] >> bScale[ bLevel ][ _RIGHT ], _HIGHLIGHT );
                        vDisplayVolume( bSliderX[ bLevel ][ _RIGHT ] - 3, bSliderY[ bLevel ][ _RIGHT ] + _METER_SIZE + 3, fVolumeLevels[ bMeterTable[ bLevel ] ][ bVolumeLevel[ bLevel ][ _RIGHT ] ], _HIGHLIGHT, bLevel );
                        }
					break;
						
					
				default:
					break;
				}

            switch( bLevel )
            	{
            	case _MASTER_VOLUME:
            		bWrMReg( _MREG_PM_MASTERL_VOLUME, bVolumeLevel[ bLevel ][ _LEFT ] );
            		bWrMReg( _MREG_PM_MASTERR_VOLUME, bVolumeLevel[ bLevel ][ _LEFT ] );
            		break;
            		
            	case _WAVEIN_VOLUME:
            		iWrXReg( _XREG_RM_WAVEIN_VOLUME, (BYTE)( ( bVolumeLevel[ bLevel ][ _LEFT ] << 4 ) | bVolumeLevel[ bLevel ][ _RIGHT ] ) );
            		break;
            		
            	default:
            		bWrMReg( bVolumeRegs[ bLevel ][ _LEFT ], (BYTE)( ( bVolumeLevel[ bLevel ][ _LEFT ] << 4 ) | bVolumeLevel[ bLevel ][ _RIGHT ] ) );
            		break;
            	}
			}
		}
	while( bInkey != 0x1B );

	vClearScreen();
	
	gbMasterVolumeL = bVolumeLevel[_MASTER_VOLUME][ _LEFT ];
	gbMasterVolumeR = bVolumeLevel[_MASTER_VOLUME][ _RIGHT ];

	gbWaveInVolumeL = bVolumeLevel[_WAVEIN_VOLUME][ _LEFT ];
	gbWaveInVolumeR = bVolumeLevel[_WAVEIN_VOLUME][ _RIGHT ];

	gbWaveOutVolumeL = bVolumeLevel[_WAVEOUT_VOLUME][ _LEFT ];
	gbWaveOutVolumeR = bVolumeLevel[_WAVEOUT_VOLUME][ _RIGHT ];
	
	gbMonoInVolumeL = bVolumeLevel[_MONOIN_VOLUME][ _LEFT ];
	gbMonoInVolumeR = bVolumeLevel[_MONOIN_VOLUME][ _RIGHT ];

	gbFMSynthVolumeL = bVolumeLevel[ _FMSYNTH_VOLUME ][ _LEFT ];
	gbFMSynthVolumeR = bVolumeLevel[ _FMSYNTH_VOLUME ][ _RIGHT ];
	
	gbMicVolumeL = bVolumeLevel[_MIC_VOLUME][ _LEFT ];
	gbMicVolumeR = bVolumeLevel[_MIC_VOLUME][ _RIGHT ];

	gbLineInVolumeL = bVolumeLevel[_LINEIN_VOLUME][ _LEFT ];
	gbLineInVolumeR = bVolumeLevel[_LINEIN_VOLUME][ _RIGHT ];

	gbCDLineInVolumeL = bVolumeLevel[_CDLINEIN_VOLUME][ _LEFT ];
	gbCDLineInVolumeR = bVolumeLevel[_CDLINEIN_VOLUME][ _RIGHT ];

	bWrConfigFile( _CONFIG_FILE_NAME );
	}

/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
void	vDisplayTolerance( int x, int y, BYTE _bLevel, BYTE _bMode )
	{
	char	szTmpStr[80];
	
    sprintf( szTmpStr, "%c% 2u%%", 0xF1, _bLevel );
	
	switch( _bMode )
		{
		case _NORMAL:
			vPrintStringXY( x, y, szTmpStr, _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
			break;
			
		case _HIGHLIGHT:	
			vPrintStringXY( x, y, szTmpStr, _MNU_HIGHLIGHT_FGCOLOR, _MNU_HIGHLIGHT_BGCOLOR );
			break;
		}
	}

/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
void	vDrawToleranceMeter( int _iX, int _iY, int _iSize, unsigned int _iLevel, BYTE _bMode )
	{
	BYTE	bIndex;
	WORD	wLevel = (WORD)( _iLevel / 10 );

	switch( _bMode )
		{
		case _NORMAL:
			vDrawBox(	_iX - 1, _iY - 2, _iX + 1, _iY + 1 + _iSize, _BOX_SINGLE, _MNU_WINDOW_FGCOLOR, _MNU_WINDOW_BGCOLOR );
				
			vPrintCharXY( _iX, (BYTE)(_iY - 1), 0x1E, _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
			
			for( bIndex=0; bIndex < _iSize; bIndex++ )
				{
				vPrintCharXY( _iX, (BYTE)(_iY + bIndex), 0xB0, _MNU_WINDOW_FGCOLOR, _MNU_WINDOW_BGCOLOR );
				}
		
			vPrintCharXY( _iX, (BYTE)(_iY + bIndex), 0x1F, _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
			
			vPrintCharXY( _iX, (BYTE)(_iY + _iSize - wLevel - 1 ), ' ', _MNU_TEXT_BGCOLOR, _MNU_TEXT_FGCOLOR );
			break;
			
		case _HIGHLIGHT:
			vDrawBox(	_iX - 1, _iY - 2, _iX + 1, _iY + 1 + _iSize, _BOX_DOUBLE, _MNU_HIGHLIGHT_FGCOLOR, _MNU_HIGHLIGHT_BGCOLOR );

			vPrintCharXY( _iX, (BYTE)(_iY - 1), 0x1E, _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
			
			for( bIndex=0; bIndex < _iSize; bIndex++ )
				{
				vPrintCharXY( _iX, (BYTE)(_iY + bIndex), 0xB0, _MNU_WINDOW_FGCOLOR, _MNU_WINDOW_BGCOLOR );
				}
		
			vPrintCharXY( _iX, (BYTE)(_iY + bIndex), 0x1F, _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
			
			vPrintCharXY( _iX, (BYTE)(_iY + _iSize - wLevel - 1), ' ', _MNU_HIGHLIGHT_BGCOLOR, _MNU_HIGHLIGHT_FGCOLOR );
			break;	
		}

    vDisplayTolerance( (int)( _iX - 2 ), (int)( _iY + 3 + _iSize ), LOBYTE( _iLevel ), _bMode );
	}	

/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
void	vSetToleranceLevels( void )
	{
	BYTE	bInkey = 0;
	
    static BYTE    bLevel = 0;
	
	BYTE	bIndex;

    char	szTmpStr[80];
	
	BYTE	bToleranceLevel[_MAX_TOLERANCE_CONTROLS];
	
    BYTE    bSliderY[ _MAX_TOLERANCE_CONTROLS ] =  {  8,  8,  8,  8,  8 };
    BYTE    bSliderX[ _MAX_TOLERANCE_CONTROLS ] =  { 17, 28, 39, 50, 61 };

    BYTE    bSliderMax[ _MAX_TOLERANCE_CONTROLS ] ={ 79, 79, 79, 79, 79 };
	
	vClearScreen();
	vDisplayConfig();
    sprintf( szTmpStr, "Press %c/%c to select, %c/%c adjust level, esc to return to main menu", 0x1B, 0x1A, 0x18, 0x19 );
    vDisplayOptionMessage( szTmpStr );

    vPrintStringXY( bSliderX[_MONOIN_TOLERANCE] - 3, bSliderY[_MONOIN_TOLERANCE] - 3, "MonoIn", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( bSliderX[_MIC_TOLERANCE] - 1, bSliderY[_MIC_TOLERANCE] - 3, "Mic", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( bSliderX[_LINEIN_TOLERANCE] - 2, bSliderY[_LINEIN_TOLERANCE] - 3, "LineIn", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( bSliderX[_CDLINEIN_TOLERANCE] - 1, bSliderY[_CDLINEIN_TOLERANCE] - 3, "CD", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( bSliderX[_JOYSTICK_TOLERANCE] - 2, bSliderY[_JOYSTICK_TOLERANCE] - 3, "Game", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );

    bToleranceLevel[ _MONOIN_TOLERANCE ] = gbMonoInTolerance;
    bToleranceLevel[ _MIC_TOLERANCE ] = gbMicTolerance;
    bToleranceLevel[ _LINEIN_TOLERANCE ] = gbLineInTolerance;
    bToleranceLevel[ _CDLINEIN_TOLERANCE ] = gbCDLineInTolerance;
    bToleranceLevel[ _JOYSTICK_TOLERANCE ] = gbJoystickTolerance;
	

	for( bIndex=0; bIndex < _MAX_TOLERANCE_CONTROLS; bIndex++ )
		{
        vDrawToleranceMeter( bSliderX[ bIndex ], bSliderY[ bIndex ], _METER_SIZE, bToleranceLevel[ bIndex ], _NORMAL );
		}

        vDrawToleranceMeter( bSliderX[ bLevel ], bSliderY[ bLevel ], _METER_SIZE, bToleranceLevel[ bLevel ], _HIGHLIGHT );
	
	do
		{
		if( kbhit() )
			{
			bInkey = (BYTE)getch();
			switch( bInkey )
				{
				case 0x4B:
					if( bLevel > 0 )
						{
                        vDrawToleranceMeter( bSliderX[ bLevel ], bSliderY[ bLevel ], _METER_SIZE, bToleranceLevel[ bLevel ], _NORMAL );
						--bLevel;                                                                                  
                        vDrawToleranceMeter( bSliderX[ bLevel ], bSliderY[ bLevel ], _METER_SIZE, bToleranceLevel[ bLevel ], _HIGHLIGHT );
						}
					break;
					
				case 0x4D:
					if( bLevel < ( _MAX_TOLERANCE_CONTROLS - 1 ) )
						{
                        vDrawToleranceMeter( bSliderX[ bLevel ], bSliderY[ bLevel ], _METER_SIZE, bToleranceLevel[ bLevel ], _NORMAL );
						++bLevel;
                        vDrawToleranceMeter( bSliderX[ bLevel ], bSliderY[ bLevel ], _METER_SIZE, bToleranceLevel[ bLevel ], _HIGHLIGHT );
						}
					break;
					
				case 0x48:
					if( bToleranceLevel[ bLevel ] < bSliderMax[ bLevel ] )
						{
						++bToleranceLevel[ bLevel ];
                        vDrawToleranceMeter( bSliderX[ bLevel ], bSliderY[ bLevel ], _METER_SIZE, bToleranceLevel[ bLevel ], _HIGHLIGHT );
						}
					break;
					
				case 0x50:
					if( bToleranceLevel[ bLevel ] > 0x00 )
						{
						--bToleranceLevel[ bLevel ];
                        vDrawToleranceMeter( bSliderX[ bLevel ], bSliderY[ bLevel ], _METER_SIZE, bToleranceLevel[ bLevel ], _HIGHLIGHT );
						}
					break;
						
					
				default:
					break;
				}
			}
		}
	while( bInkey != 0x1B );

	vClearScreen();
	
    gbMicTolerance = bToleranceLevel[ _MIC_TOLERANCE ];
    gbLineInTolerance = bToleranceLevel[ _LINEIN_TOLERANCE ];
    gbCDLineInTolerance = bToleranceLevel[ _CDLINEIN_TOLERANCE ];
    gbJoystickTolerance = bToleranceLevel[ _JOYSTICK_TOLERANCE ];
    gbMonoInTolerance = bToleranceLevel[ _MONOIN_TOLERANCE ];

	bWrConfigFile( _CONFIG_FILE_NAME );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDisplayTitle( const char *_lpTitleMessage )
	{
    BYTE    bStrLen = (BYTE)( strlen( _lpTitleMessage ) + 2 );

    vDrawBox(   (BYTE)( ( wGetMaxX() >> 1 ) - ( bStrLen >> 1 ) ),       \
                (BYTE)( _TTL_WINDOW_POSY - ( _TTL_WINDOW_SIZE >> 1 ) ), \
                (BYTE)( ( wGetMaxX() >> 1 ) + ( bStrLen >> 1 ) ),       \
                (BYTE)( _TTL_WINDOW_POSY + ( _TTL_WINDOW_SIZE >> 1 ) ), \
                _BOX_SINGLE,                                    \
                _TTL_TEXT_FGCOLOR,                                  \
                _TTL_TEXT_BGCOLOR   );

    vDisplayCenteredString( (BYTE)_TTL_WINDOW_POSY, _lpTitleMessage, _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDisplayOptionMessage( const char *_lpOptionMessage )
	{
	BYTE	bTmpCol,
			bTmpMaxCol = (BYTE)wGetMaxX();
	
	for( bTmpCol=0; bTmpCol < bTmpMaxCol; bTmpCol++ )
        vPutCharXY( (BYTE)bTmpCol, (BYTE)_OPT_WINDOW_POSY, (char)' ', _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
		
    vDisplayCenteredString( (BYTE)_OPT_WINDOW_POSY, _lpOptionMessage, _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDisplayStatusMessage( const char *_lpStatusMessage )
	{
    BYTE    bStrLen = (BYTE)( strlen( _lpStatusMessage ) + 2 );

    vDrawBox(   (BYTE)( ( wGetMaxX() >> 1 ) - ( bStrLen >> 1 ) ),		\
                (BYTE)( _STA_WINDOW_POSY - ( _STA_WINDOW_SIZE >> 1 ) ), \
                (BYTE)( ( wGetMaxX() >> 1 ) + ( bStrLen >> 1 ) ),       \
                (BYTE)( _STA_WINDOW_POSY + ( _STA_WINDOW_SIZE >> 1 ) ), \
                _BOX_SINGLE,                                    \
                _STA_TEXT_FGCOLOR,                              \
                _STA_TEXT_BGCOLOR );

    vDisplayCenteredString( (BYTE)_STA_WINDOW_POSY, _lpStatusMessage, _STA_TEXT_FGCOLOR, _STA_TEXT_BGCOLOR );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDisplayErrorMessage( const char *_lpErrorMessage )
	{
    BYTE    bStrLen = (BYTE)( strlen( _lpErrorMessage ) + 2 );

    vDrawBox(   (BYTE)( ( wGetMaxX() >> 1 ) - ( bStrLen >> 1 ) ),		\
                (BYTE)( _ERR_WINDOW_POSY - ( _ERR_WINDOW_SIZE >> 1 ) ), \
                (BYTE)( ( wGetMaxX() >> 1 ) + ( bStrLen >> 1 ) ),       \
                (BYTE)( _ERR_WINDOW_POSY + ( _ERR_WINDOW_SIZE >> 1 ) ), \
                _BOX_SINGLE,                                    \
                _ERR_TEXT_FGCOLOR,                              \
                _ERR_TEXT_BGCOLOR );

    vDisplayCenteredString( (BYTE)_ERR_WINDOW_POSY, _lpErrorMessage, _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vDisplayHeader( void )
	{
    vDrawBox( 0, 0, wGetMaxX(), _TTL_WINDOW_SIZE, _BOX_DOUBLE_TOP, _TTL_WINDOW_FGCOLOR, _TTL_WINDOW_BGCOLOR );

    vDisplayCenteredString( 1, _BT_TITLE, _TTL_HIGHLIGHT_FGCOLOR, _TTL_HIGHLIGHT_BGCOLOR );
    vDisplayCenteredString( 2, _COPYRIGHT, _TTL_HIGHLIGHT_FGCOLOR, _TTL_HIGHLIGHT_BGCOLOR );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vDisplayFooter( void )
	{
	char    szTmpStr[80];

	BYTE bScreenRow = (BYTE)_CFG_WINDOW_POSY;
    
    vDrawBox(   0,                                                          \
                (BYTE)(_CFG_WINDOW_POSY - ( _CFG_WINDOW_SIZE >> 1 ) ),      \
                wGetMaxX(),                                                 \
                (BYTE)(_CFG_WINDOW_POSY + ( _CFG_WINDOW_SIZE >> 1 ) ),      \
                _BOX_DOUBLE,                                           		\
                _TTL_WINDOW_FGCOLOR, _TTL_WINDOW_BGCOLOR );
	
    vPrintStringXY( 2, _CFG_WINDOW_POSY - 1, "PCI", _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );
    sprintf( szTmpStr, "%04X", gwIOPCI );
    vPrintStringXY( 2, _CFG_WINDOW_POSY, szTmpStr, _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );

    vPrintStringXY( 7, _CFG_WINDOW_POSY - 1, "DDMA", _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );
    sprintf( szTmpStr, "%04X", gwIODMA[0] );
    vPrintStringXY( 7, _CFG_WINDOW_POSY, szTmpStr, _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );

    vPrintStringXY( 13, _CFG_WINDOW_POSY - 1, "IO", _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );
    sprintf( szTmpStr, "%04X", gwIOAudio );
    vPrintStringXY( 12, _CFG_WINDOW_POSY, szTmpStr, _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );

    vPrintStringXY( 17, _CFG_WINDOW_POSY - 1, "IRQ", _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );
    sprintf( szTmpStr, "%1X", gbIRQAudio );
    vPrintStringXY( 18, _CFG_WINDOW_POSY, szTmpStr, _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );

    vPrintStringXY( 21, _CFG_WINDOW_POSY - 1, "MIDI", _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );
    sprintf( szTmpStr, "%04X", gwIOMPU401 );
    vPrintStringXY( 21, _CFG_WINDOW_POSY, szTmpStr, _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );

    vPrintStringXY( 27, _CFG_WINDOW_POSY - 1, "GAME", _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );
    sprintf( szTmpStr, "%04X", gwIOJoystick );
    vPrintStringXY( 27, _CFG_WINDOW_POSY, szTmpStr, _TTL_TEXT_FGCOLOR, _TTL_TEXT_BGCOLOR );


    vPrintStringXY( 48, _CFG_WINDOW_POSY, "Mic",                            \
                    (BYTE)( flgTestMic ? _TTL_HIGHLIGHT_FGCOLOR : _STA_TEXT_FGCOLOR ),\
                    (BYTE)( flgTestMic ? _TTL_HIGHLIGHT_BGCOLOR : _STA_TEXT_BGCOLOR ) );

    vPrintStringXY( 52, _CFG_WINDOW_POSY, "LineIn",                         \
                    (BYTE)( flgTestLineIn ? _TTL_HIGHLIGHT_FGCOLOR : _STA_TEXT_FGCOLOR ), \
                    (BYTE)( flgTestLineIn ? _TTL_HIGHLIGHT_BGCOLOR : _STA_TEXT_BGCOLOR ) );

    vPrintStringXY( 59, _CFG_WINDOW_POSY, "CD",                             \
                    (BYTE)( flgTestCDLineIn ? _TTL_HIGHLIGHT_FGCOLOR : _STA_TEXT_FGCOLOR ), \
                    (BYTE)( flgTestCDLineIn ? _TTL_HIGHLIGHT_BGCOLOR : _STA_TEXT_BGCOLOR ) );

    vPrintStringXY( 62, _CFG_WINDOW_POSY, "MonoIn",                           \
                    (BYTE)( flgTestMonoIn ? _TTL_HIGHLIGHT_FGCOLOR : _STA_TEXT_FGCOLOR ), \
                    (BYTE)( flgTestMonoIn ? _TTL_HIGHLIGHT_BGCOLOR : _STA_TEXT_BGCOLOR ) );

    vPrintStringXY( 69, _CFG_WINDOW_POSY, "Midi",                           \
                    (BYTE)( flgTestMPU401 ? _TTL_HIGHLIGHT_FGCOLOR : _STA_TEXT_FGCOLOR ), \
                    (BYTE)( flgTestMPU401 ? _TTL_HIGHLIGHT_BGCOLOR : _STA_TEXT_BGCOLOR ) );

    vPrintStringXY( 74, _CFG_WINDOW_POSY, "Game",                           \
                    (BYTE)( flgTestJoystick ? _TTL_HIGHLIGHT_FGCOLOR : _STA_TEXT_FGCOLOR ), \
                    (BYTE)( flgTestJoystick ? _TTL_HIGHLIGHT_BGCOLOR : _STA_TEXT_BGCOLOR ) );

	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDisplayConfig( void )
	{
    vClearScreen();
	vDisplayHeader();
	vDisplayFooter();

    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDisplayMenu( void )
	{
    BYTE    bScreenRow = _TTL_WINDOW_SIZE + 2,
            bScreenCol = 26;
	
        vPrintStringXY( bScreenCol, bScreenRow++, " [A] Test All Options       ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );

        vPrintStringXY( bScreenCol, bScreenRow++, " [C] Test Configuration     ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
	if( flgTestMonoIn )
        vPrintStringXY( bScreenCol, bScreenRow++, " [I] Test MonoIn Loopback   ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    if( flgTestMic )
        vPrintStringXY( bScreenCol, bScreenRow++, " [M] Test Mic Loopback      ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    if( flgTestLineIn )
        vPrintStringXY( bScreenCol, bScreenRow++, " [L] Test LineIn Loopback   ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    if( flgTestMic )
        vPrintStringXY( bScreenCol, bScreenRow++, " [D] Test CDLineIn Loopback ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    if ( flgTestMPU401 )
        vPrintStringXY( bScreenCol, bScreenRow++, " [P] Test Midi Port         ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    if ( flgTestJoystick )
        vPrintStringXY( bScreenCol, bScreenRow++, " [G] Test Game Port         ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );

        vPrintStringXY( bScreenCol, bScreenRow++, " [V] Set Volume Levels      ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );

        vPrintStringXY( bScreenCol, bScreenRow++, " [T] Set Tolerance Levels   ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );

        vPrintStringXY( bScreenCol, bScreenRow++, " [R] ReInitialize Chip      ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );

        vPrintStringXY( bScreenCol, bScreenRow++, " [S] Modify Setup           ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );

        vPrintStringXY( bScreenCol, bScreenRow++, " [Q] Quit                   ", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDisplayTime( void )
	{
	static BYTE     abCurrentTimeString[ 0x50 ];

    BYTE    aszTmpStr[ 0x50 ];

	tzset(  );
	_strtime( (char *)abCurrentTimeString );

    sprintf( (char *)aszTmpStr, "Current Time: %s", abCurrentTimeString );
	
    vPrintStringXY( 3, _TIM_WINDOW_POSY, (char *)aszTmpStr, _TIM_TEXT_FGCOLOR, _TIM_TEXT_BGCOLOR );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDisplayDebugMessage( const char *_lpDebugMessage, ... )
	{
#ifdef	_DEBUG
	FILE	*fStream;

	char	abTmpStr[80];   

	BYTE	bIndex,
			bTmpIndex,
			bLoopFlag;
	
	va_list marker;
	         
	va_start( marker, _lpDebugMessage );     

    if( ( fStream = fopen( "MON", "wt" ) ) != NULL )
    	{
		for( bIndex=0; bIndex < strlen( _lpDebugMessage ); bIndex++ )
			{
			if( _lpDebugMessage[bIndex] == '%' )
				{
				bTmpIndex = 0;
				bLoopFlag = TRUE;

				do
					{
					abTmpStr[ bTmpIndex ] = _lpDebugMessage[bIndex];

					abTmpStr[bTmpIndex+1] = '\x0';

					switch( abTmpStr[bTmpIndex] )
						{
						case 'c':
							fprintf( fStream, abTmpStr, (unsigned char)va_arg( marker, unsigned char ) );
							bLoopFlag = FALSE;
							break;
								
						case 's':
							fprintf( fStream, abTmpStr, (char far *)va_arg( marker, unsigned long ) );
							bLoopFlag = FALSE;
							break;
	
						case 'x':
						case 'X':
							fprintf( fStream, abTmpStr, (BYTE)va_arg( marker, BYTE ) );
							bLoopFlag = FALSE;
							break;
	
                        case 'u':
							fprintf( fStream, abTmpStr, (unsigned int)va_arg( marker, unsigned int ) );
							bLoopFlag = FALSE;
							break;
	                        
                        case 'd':
							fprintf( fStream, abTmpStr, (int)va_arg( marker, int ) );
							bLoopFlag = FALSE;
							break;
	                        
						default:
							break;
						}    
						
					if( bLoopFlag )
						{	
						++bIndex;
						++bTmpIndex;
						}
					}
				while( bLoopFlag == TRUE );
				}
			else
				{	
				fprintf( fStream, "%c", _lpDebugMessage[bIndex] );
				}
			}
    	}
    fclose( fStream );	
#endif
	}	

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int		iDisplayIntOptions( BYTE _bCol, BYTE _bRow, const char *_lpszTitle, int *_Options, BYTE _bSelect, BYTE _bHLIndex, BYTE _bAlign, BYTE _bFormat )
	{
	MENU	sMenu;
	
	OPTION	Option[20];	/* Maximum of 20 Options */
	
	BYTE	bCount;
	
	strcpy( (char *)sMenu.szMenuTitle, _lpszTitle);

	sMenu.bMaxLength = (BYTE)strlen( (char *)sMenu.szMenuTitle );
	
	sMenu.sTitle.bFGColor = _MNU_TITLE_FGCOLOR;
	sMenu.sTitle.bBGColor = _MNU_TITLE_BGCOLOR;

	sMenu.sText.bFGColor = _MNU_TEXT_FGCOLOR;
	sMenu.sText.bBGColor = _MNU_TEXT_BGCOLOR;

	sMenu.sHighLight.bFGColor = _MNU_HIGHLIGHT_FGCOLOR;
	sMenu.sHighLight.bBGColor = _MNU_HIGHLIGHT_BGCOLOR;

	sMenu.sMenuBar.bFGColor = _MNU_MENUBAR_FGCOLOR;
	sMenu.sMenuBar.bBGColor = _MNU_MENUBAR_BGCOLOR;

    sMenu.sBorder.bFGColor = _MNU_WINDOW_FGCOLOR;
    sMenu.sBorder.bBGColor = _MNU_WINDOW_BGCOLOR;

	sMenu.Option = Option;
	sMenu.bRow = _bRow;
	sMenu.bCol = _bCol;
	sMenu.bAlign = _bAlign;
		
	for( bCount=0; _Options[bCount] != -1; bCount++ )
		{
		switch( _bFormat )
			{
			case _BYTE_DISPLAY:
				sprintf( Option[bCount].szOption, "%02X", _Options[bCount] );
				break;

			case _WORD_DISPLAY:
				sprintf( Option[bCount].szOption, "%04X", _Options[bCount] );
				break;
			}
			
		if( strlen( Option[bCount].szOption ) > (WORD)sMenu.bMaxLength )
			sMenu.bMaxLength = (BYTE)strlen( Option[bCount].szOption );

		sMenu.Option[bCount].bHotKeyIndex = _bHLIndex;
		}
	
	sMenu.Option[bCount].szOption[0] = 0;
	
	return( _Options[ iDisplayMenu( (BYTE)( _bCol - ( sMenu.bMaxLength >> 1 ) ), _bRow - ( bCount >> 1 ), &sMenu, _bSelect ) ] );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int		iDisplayStringOptions( BYTE _bCol, BYTE _bRow, const char *_lpszTitle, OPTION *_Options, BYTE _bSelect, BYTE _bAlign )
	{
	MENU	sMenu;
	
	BYTE	bCount;
	
	strcpy( (char *)sMenu.szMenuTitle, _lpszTitle);

	sMenu.bMaxLength = (BYTE)strlen( _lpszTitle );

	sMenu.sTitle.bFGColor = _MNU_TITLE_FGCOLOR;
	sMenu.sTitle.bBGColor = _MNU_TITLE_BGCOLOR;

	sMenu.sText.bFGColor = _MNU_TEXT_FGCOLOR;
	sMenu.sText.bBGColor = _MNU_TEXT_BGCOLOR;

	sMenu.sHighLight.bFGColor = _MNU_HIGHLIGHT_FGCOLOR;
	sMenu.sHighLight.bBGColor = _MNU_HIGHLIGHT_BGCOLOR;

	sMenu.sMenuBar.bFGColor = _MNU_MENUBAR_FGCOLOR;
	sMenu.sMenuBar.bBGColor = _MNU_MENUBAR_BGCOLOR;

    sMenu.sBorder.bFGColor = _MNU_WINDOW_FGCOLOR;
    sMenu.sBorder.bBGColor = _MNU_WINDOW_BGCOLOR;

	sMenu.Option = (OPTION*)_Options;
	sMenu.bRow = _bRow;
	sMenu.bCol = _bCol;
	sMenu.bAlign = _bAlign;

	for( bCount=0; _Options[bCount].szOption[0] != 0x00; bCount++ )
		{
		
		if( strlen( _Options[bCount].szOption ) > (WORD)sMenu.bMaxLength )
			sMenu.bMaxLength = (BYTE)strlen( _Options[bCount].szOption );
		}
	
	_Options[bCount].szOption[0] = 0;
	
	return( iDisplayMenu( (BYTE)( _bCol - ( sMenu.bMaxLength >> 1 ) ), _bRow, &sMenu, _bSelect ) );
	}

