#include	<stdio.h>
#include	<stdlib.h>

#include	"stdtype.h"
#include	"config.h"
#include	"1938.h"
#include	"mixer.h"
#include	"mpu401.h"
#include	"es6xx.h"
#include	"screenio.h"
#include	"display.h"

BYTE    ab690SysExMessages[2][6] = {	{0xF0, 0x00, 0x00, 0x7B, 0x01, 0xF7},
										{0xF0, 0x00, 0x00, 0x7B, 0x04, 0xF7}	};

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int     iResetES690( void )
	{
	int     iRetVal = _ES_MPU401_ERROR;

	vDisplayDebugMessage( "iReset690\n" );

	if ( iResetMPU401(  ) != _ES_MPU401_ERROR )
		{
		if ( iEnableUartMode(  ) != _ES_MPU401_ERROR )
			{
			if ( iSendSysExMessage( ab690SysExMessages[1] ) != _ES_MPU401_ERROR )
				{
				vDisplayDebugMessage( "ES690 Reset\n" );
				iRetVal = _ES_MPU401_OK;
				}
			else
				{
				vDisplayDebugMessage( "Unable to send SysEx DAC control\n" );
				}
			}
		else
			{
			vDisplayDebugMessage( "Unable to enable UART mode\n" );
			}
		}
	else
		{
		vDisplayDebugMessage( "Unable to reset MPU401 port\n" );
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vEnable689( void )
	{
	switch ( gwIOMPU401 )
		{
		case 0x300:
			bWrMReg( 0x40, ( BYTE ) ( ( bRdMReg( 0x40 ) & 0xE7 ) | 0x00 ) );
			break;

		case 0x310:
			bWrMReg( 0x40, ( BYTE ) ( ( bRdMReg( 0x40 ) & 0xE7 ) | 0x08 ) );
			break;

		case 0x320:
			bWrMReg( 0x40, ( BYTE ) ( ( bRdMReg( 0x40 ) & 0xE7 ) | 0x10 ) );
			break;

		case 0x330:
			bWrMReg( 0x40, ( BYTE ) ( ( bRdMReg( 0x40 ) & 0xE7 ) | 0x18 ) );
			break;
			}

	bSetMRegBit( 0x48, 4 );

	iResetES690(  );
	}
