#include    <stdio.h>
#include	<stdlib.h>
#include	<string.h>	
#include	<dos.h>
#include	<conio.h>
#include	<ctype.h>
#include	<time.h>
#include	<fcntl.h>
#include	<io.h>
#include    <graph.h>

#include	"stdtype.h"
#include	"config.h"
#include	"1938.h"
#include	"dsp.h"
#include	"mixer.h"
#include    "delay.h"
#include    "mpu401.h"
#include    "pciio.h"
#include    "screenio.h"
#include    "display.h"
#include    "fmsynth.h"
#include	"ic8237.h"
#include	"ic8259.h"
#include    "play.h"

#include	"main.h"

/* Special key blocking treatment */
void    ( interrupt _far * org_v5h ) (  );
void    ( interrupt _far * org_v23h ) (  );

/* Prototype statements */

void interrupt _far disb_key( void );
void    disable_key( void );
void    enable_key( void );

#define _TST_SAMPLE_RATE    22050L

#define MAXENTRY    6

		
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	main( void )
    {
    gbCenterX = (BYTE)( wGetMaxX() >> 1 );
    gbCenterY = _TTL_WINDOW_POSY + 3;

    vDisableCursor();

    gwChipType = _CHIPTYPE;
    
    bRdConfigFile( _CONFIG_FILE_NAME );

    gbPCIBios = TRUE;

//    vSaveMixer();

    vConfigureAudioDrive();

    vMainTestLoop();

//    vRestoreMixer();

    vEnableCursor();

    vClearScreen();

    vSetCursorPosition( 1, 1 );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int     vMainTestLoop( void )
	{
    BYTE    bInKey = 0,
            bDisplayMenu = TRUE;

	disable_key(  );

	do
		{
        if( bDisplayMenu )
            {
            bDisplayMenu = FALSE;
            vDisplayConfig();
            vDisplayMenu(  );
            }

		if ( kbhit(  ) )
			{
			bInKey = (BYTE)getch();

			if ( isalpha( bInKey ) )
                {
				bInKey = (BYTE)tolower( bInKey );

                switch ( bInKey )
                    {

                    case 'a':
                        vTestAllOptions(  );
                        bDisplayMenu = TRUE;
                        break;

                    case 'c':
                        bTestConfig();
                        bDisplayMenu = TRUE;
                        break;

                    case 'i':
                        if( flgTestMonoIn )
                            {
                            bTestMonoInLoopback();
                            bDisplayMenu = TRUE;
                            }
                        break;

                    case 'm':
                        if( flgTestMic )
                            {
                            bTestMicLoopback();
                            bDisplayMenu = TRUE;
                            }
                        break;

                    case 'l':
                        if( flgTestLineIn )
                            {
                            bTestLineInLoopback();
                            bDisplayMenu = TRUE;
                            }
                        break;

                    case 'd':
                        if( flgTestCDLineIn )
                            {
                            bTestCDLineInLoopback();
                            bDisplayMenu = TRUE;
                            }
                        break;

                    case 'g':
                        if ( flgTestJoystick )
                            {
                            bTestJoystick(  );
                            bDisplayMenu = TRUE;
                            }
                        break;

                    case 'p':
                        if ( flgTestMPU401 )
                            {
                            bTestMPU401(  );
                            bDisplayMenu = TRUE;
                            }
                        break;

                    case 's':
                        vConfigureSetup();
                        vConfigureAudioDrive();
                        bDisplayMenu = TRUE;
                        break;

                    case 'v':
                        vSetVolumeLevels();
                        bDisplayMenu = TRUE;
                        break;

                    case 't':
                        vSetToleranceLevels();
                        bDisplayMenu = TRUE;
                        break;

                    case 'r':
                        vConfigureAudioDrive();
                        bDisplayMenu = TRUE;
                        break;

                    case 'q':
                        break;
                    }
                }
			}
		}

	while ( bInKey != 'q' );

	enable_key(  );

	return ( TRUE );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vTestAllOptions( void )
	{
	flgAutoMode = TRUE;

    if( bTestConfig(  ) == TRUE )
		{
		if( flgTestMic )
			bTestMicLoopback();
			
		if( flgTestLineIn )
			bTestLineInLoopback();
			
		if( flgTestCDLineIn )
			bTestCDLineInLoopback();

        if( flgTestMonoIn )
            bTestMonoInLoopback();

		if ( flgTestMPU401 )
			bTestMPU401(  );

        if ( flgTestJoystick )
            bTestJoystick(  );
		}

	flgAutoMode = FALSE;
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vCheckAutoMode( BYTE _bStatus )
	{       
    BYTE    bTimeoutFlag = FALSE;

    if( ( _bStatus == FALSE ) || ( flgAutoMode == FALSE ) )
        {
        vDisplayOptionMessage( "Press any key to to continue" );
        getch();
        }
    else
        {
        if( flgAutoMode == TRUE )
            {
            vSetEventWait( _1_SECOND * 3, (LPBYTE)&bTimeoutFlag );

            while( bTimeoutFlag == FALSE )
                {
                if( kbhit() )
                    {
                    getch();
                    break;
                    }
                }

            vClearEventWait();
            }
        }
	}               

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void interrupt far disb_key( void )
	{
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    disable_key( void )
	{
	org_v5h = _dos_getvect( 0x5 );
	org_v23h = _dos_getvect( 0x23 );
	_disable(  );
	_dos_setvect( 0x5, disb_key );
	_dos_setvect( 0x23, disb_key );
	_enable(  );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    enable_key( void )
	{
	_disable(  );
	_dos_setvect( 0x5, org_v5h );
	_dos_setvect( 0x23, org_v23h );
	_enable(  );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTestSpeaker( void )
    {
    BYTE    bRetVal = FALSE;

    if( iEnableDAC() != _ES_DSP_ERROR )
        {
        if ( iGetDACStatus(  ) == 0xFF )
            {
            if( iDisableDAC() != _ES_DSP_ERROR )
                {
                if( iGetDACStatus() == 0x00 )
                    {
                    bRetVal = TRUE;
                    }
                }
            }
        }
    return( bRetVal );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTestRomIDCode( void )
    {
    BYTE    bRetVal = FALSE;

    if( bRdMReg( 0x40 ) == 0x19 )
        {
        if( bRdMRegData() == 0x69 )
            {
            bRetVal = TRUE;
            }
        }

    return( bRetVal );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTestVersion( void )
    {
    BYTE    bRetVal = TRUE;


    if( iWrDSP( 0xE1 ) == _ES_DSP_OK )
        {
        if( iRdDSP() == 0x03 )
            {
            if( iRdDSP() == 0x01 )
                {
                if( iWrDSP( 0xE7 ) == _ES_DSP_OK )
                    {
                    if( iRdDSP() == 0x68 )
                        {
                        if( BTSTBIT( iRdDSP(), 7 ) == TRUE )
                            {
                            bRetVal = TRUE;
                            }
                        }
                    }
                }
            }
        }
    return( bRetVal );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTestXRegisters( void )
    {
    BYTE    bRetVal = FALSE;

    if( iResetFIFO() == _ES_DSP_RESET_OK )
        {
        if( iEnableExtendedMode(  ) != _ES_DSP_ERROR )
            {
            if( iRdXReg(0xa4) == 0x00 )
                {
                if( iRdXReg(0xa5) == 0xF8 )
                    {
                    if( iRdXReg(0xB4) == 0xFF )
                        {
                        bRetVal = TRUE;
                        }
                    }
                }
            }
        }
    return( bRetVal );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTestMixer( void )
    {
    BYTE    bRetVal = TRUE;

    vResetMixer();

    if( bRdMReg( _MREG_PM_WAVE_VOLUME ) != 0x88 )
		{
        vDisplayDebugMessage( "ERROR: MReg 0x14 Failed" );
        bRetVal = FALSE;
		}

    if( bRdMReg( _MREG_PM_FMSYNTH_VOLUME ) != 0x88 )
		{
        vDisplayDebugMessage( "ERROR: MReg 0x36 Failed" );
        bRetVal = FALSE;
        }

    if( bRdMReg( _MREG_PM_MIC_VOLUME ) != 0x00 )
        {
        vDisplayDebugMessage( "ERROR: MReg 0x1A Failed" );
        bRetVal = FALSE;
        }

    if( bRdMReg( _MREG_PM_WAVE_VOLUME ) != 0x88 )
		{
        vDisplayDebugMessage( "ERROR: MReg 0x14 Failed" );
        bRetVal = FALSE;
        }

    if( bRdMReg( _MREG_PM_LINEIN_VOLUME ) != 0x00 )
        {
        vDisplayDebugMessage( "ERROR: MReg 0x3E Failed" );
        bRetVal = FALSE;
        }

    if( bRdMReg( _MREG_PM_CDLINEIN_VOLUME ) != 0x00 )
        {
        vDisplayDebugMessage( "ERROR: MReg 0x38 Failed" );
        bRetVal = FALSE;
        }

    if( bRdMReg( _MREG_PM_AUXB_VOLUME ) != 0x00 )
        {
        vDisplayDebugMessage( "ERROR: MReg 0x3A Failed" );
        bRetVal = FALSE;
        }

    if( bRdMReg( _MREG_PM_PCSPK_VOLUME ) != 0x04 )
        {
        vDisplayDebugMessage( "ERROR: MReg 0x3C Failed" );
        bRetVal = FALSE;
        }

    if( iRdXReg( _XREG_RM_WAVEIN_VOLUME ) != 0xFF )
        {
        vDisplayDebugMessage( "ERROR: XReg Register 0xB4 Failed" );
        bRetVal = FALSE;
        }

    vInitMixer();

    return( bRetVal );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTestConfig( void )
	{
    BYTE    bRetVal = TRUE;

    BYTE    bScreenRow = _TTL_WINDOW_POSY + 3;

    vDisplayConfig();
    vDisplayTitle( "Testing Configuration ...." );
    vDisplayOptionMessage( "Please Wait...." );

    vPrintStringXY( 25, bScreenRow++, "      H/W Reset:", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( 25, bScreenRow++, "      Device ID:", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( 25, bScreenRow++, "     ROM CodeID:", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( 25, bScreenRow++, "      S/W Reset:", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( 25, bScreenRow++, "    IRQ Channel:", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( 25, bScreenRow++, "    DMA Channel:", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( 25, bScreenRow++, "       FIFO RAM:", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( 25, bScreenRow++, "     DAC Status:", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( 25, bScreenRow++, "    DAC Speaker:", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );
    vPrintStringXY( 25, bScreenRow++, "Mixer Registers:", _SCR_TEXT_FGCOLOR, _SCR_TEXT_BGCOLOR );

    bScreenRow = _TTL_WINDOW_POSY + 3;

    if ( iResetFIFO(  ) == _ES_DSP_RESET_OK )
		{
        vPrintStringXY( 41, bScreenRow++, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
		}
	else
		{
        vPrintStringXY( 41, bScreenRow++, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
        bRetVal = FALSE;
        }

    if ( bTestVersion() )
		{
        vPrintStringXY( 41, bScreenRow++, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
        }
	else
		{
        vPrintStringXY( 41, bScreenRow++, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
        bRetVal = FALSE;
        }

    if( bTestRomIDCode() )
        {
        vPrintStringXY( 41, bScreenRow++, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
        }
    else
        {
        vPrintStringXY( 41, bScreenRow++, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
        bRetVal = FALSE;
        }

    if ( iResetFIFO() == _ES_DSP_RESET_OK )
		{
        vPrintStringXY( 41, bScreenRow++, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
		}
	else
		{
        vPrintStringXY( 41, bScreenRow++, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
        bRetVal = FALSE;
        }

    if ( iTestIRQChannel1( gbIRQAudio ) )
		{
        vPrintStringXY( 41, bScreenRow++, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
		}
	else
		{
        vPrintStringXY( 41, bScreenRow++, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
        bRetVal = FALSE;
        }

    if ( iTestDMAChannel1() )
		{
        vPrintStringXY( 41, bScreenRow++, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
		}
	else
		{
        vPrintStringXY( 41, bScreenRow++, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
        bRetVal = FALSE;
        }

    if ( bTestRAMFIFO() )
		{
        vPrintStringXY( 41, bScreenRow++, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
		}
	else
		{
        vPrintStringXY( 41, bScreenRow++, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
        bRetVal = FALSE;
        }

    if ( bTestXRegisters() )
		{
        vPrintStringXY( 41, bScreenRow++, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
		}
	else
		{
        vPrintStringXY( 41, bScreenRow++, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
        bRetVal = FALSE;
        }

    if ( bTestSpeaker() )
		{
        vPrintStringXY( 41, bScreenRow++, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
		}
	else
		{
        vPrintStringXY( 41, bScreenRow++, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
        bRetVal = FALSE;
        }

    if( bTestMixer() )
		{
        vPrintStringXY( 41, bScreenRow++, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
		}
	else
		{
        vPrintStringXY( 41, bScreenRow++, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
        bRetVal = FALSE;
        }
	
    vCheckAutoMode( bRetVal );

    return( bRetVal );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void _interrupt _far aiTestISR( void )
	{
	
#ifdef	_DEBUG
	BYTE	index;

	LPBYTE lpTmpPtr = ( (LPBYTE) 0xB8000000L );
		
	for( index=4; index > 0; index-- )
		{
		if( ( lpTmpPtr[index<<1] < 0x30 ) || ( lpTmpPtr[index<<1] > 0x39 ) )
			{
			lpTmpPtr[index<<1] = 0x30;
			}
		else
			{
			if( lpTmpPtr[index<<1] == 0x39 )
				{
				lpTmpPtr[index<<1] = 0x30;
				}
			else 
				{
				++lpTmpPtr[index<<1];
				break;
				}
			}
		}
#endif

    bIRQTestFlag[0] = TRUE;

	inp( gwIOAudio + 0x0E );

    outp( gwIOAudio + 0x04, 0x7a );

    outp( gwIOAudio + 0x05, BMSKBIT( inp( gwIOAudio + 0x05 ), 7 ) );

 /* Send Non-Specific EOI to controller #1 */
	outp( 0x20, 0x20 );

 /* Send Non-Specific EOI to controller #2 */
	outp( 0xa0, 0x20 );


	_enable(  );
	}

/******************************************************************************/
/* iTestDMAChannel1 - Test Primary audio DMa Channel                          */
/*                                                                            */
/******************************************************************************/
int     iTestDMAChannel1( void )
	{
	WORD    wTransferSize = 4;

	LPBYTE  lpTestPtr = ( LPBYTE ) 0x00000000L;

	iResetFIFO(  );
	iEnableExtendedMode(  );

    vSetDMATransfer( _ES_CHANNEL0, lpTestPtr, wTransferSize, _DMA_NON_AI | _DMA_INC | _DMA_SINGLE | _DMA_READ );

    iWrDSP( 0xE2 );
    iWrDSP( 0xaa );
    iWrDSP( 0xE2 );
    iWrDSP( 0xaa );

    lpTestPtr = lpGetDMAAddress( _ES_CHANNEL0, &lpTestPtr );

    vDisplayDebugMessage( "DMa Test:%08X\n", (DWORD)lpTestPtr );

	iResetFIFO(  );
	iEnableExtendedMode(  );

	return ( _FP_OFF( lpTestPtr ) );
	}

/******************************************************************************/
/* iTestIRQChannel1 - Test Primary audio IRQ Channel                          */
/*                                                                            */
/******************************************************************************/
int     iTestIRQChannel1( BYTE _bIRQChannel )
	{
    int     bRetVal = 0;

	WORD    wTimeout = _ES_DSP_RESET_TIMEOUT;

	iResetFIFO(  );
	iEnableExtendedMode(  );

	bIRQTestFlag[_bIRQChannel] = 0;

    vInstallISR( _bIRQChannel, aiTestISR );

	iWrDSP( 0xF2 );
	iWrDSP( 0xF2 );
	iWrDSP( 0xF2 );

    while ( --wTimeout && !bRetVal )
        bRetVal = bIRQTestFlag[0];

	vRemoveISR( _bIRQChannel );

	iResetFIFO(  );
	iEnableExtendedMode(  );

    return ( bRetVal );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTestMonoInLoopback( void )
	{
    BYTE    bScreenRow = (BYTE)( _STA_WINDOW_POSY + 1 );

	BYTE	bRetVal = FALSE;

    WORD    wLAvg,
            wRAvg,
            wTmp;

    vDisplayConfig();
    vDisplayTitle( "Testing MonoIn Loopback...." );
    vDisplayOptionMessage( "Please Wait...." );

    vEnableSineWave();

    bWrMReg( _MREG_RM_MONOIN_VOLUME, (BYTE)( ( gbMonoInVolumeL << 4 ) | gbMonoInVolumeR ) );
    vRecord( "temp.raw", _TST_SAMPLE_RATE );
    bWrMReg( _MREG_RM_MONOIN_VOLUME, 0x00 );

    vDisableSineWave();

    wTmp = iCalcFreqStereo( "temp.raw" );
    wLAvg = _TST_SAMPLE_RATE / HIBYTE( wTmp );
    wRAvg = _TST_SAMPLE_RATE / LOBYTE( wTmp );

    vDisplayDebugMessage("LAvg:%u\n", wLAvg );
    vDisplayDebugMessage("RAvg:%u\n", wRAvg );


    if( abs( (int)( gwMonoInFrequency - wLAvg ) ) < gbMonoInTolerance )
        {
        if( abs( (int)( gwMonoInFrequency - wRAvg ) ) < gbMonoInTolerance )
            {
            vDisplayStatusMessage( "MonoIn Loopback Test: Passed" );
            bRetVal = TRUE;
            }
        else
            {
            vDisplayErrorMessage( "MonoIn Loopback Test: Right Channel Failed" );
            }
        }
    else
        {
        vDisplayErrorMessage( "MonoIn Loopback Test: Left Channel Failed" );
        bRetVal = FALSE;
        }

    vCheckAutoMode( bRetVal );

    remove("temp.raw");

    return( bRetVal );
	}
    
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE	bTestLineInLoopback( void )
	{
    BYTE    bScreenRow = (BYTE)( _STA_WINDOW_POSY + 1 );

	BYTE	bRetVal = FALSE;

    WORD    wLAvg,
            wRAvg,
            wTmp;

    vDisplayConfig();
    vDisplayTitle( "Testing LineIn Loopback...." );
    vDisplayOptionMessage( "Please Wait...." );

    vEnableSineWave();
    bWrMReg( _MREG_RM_LINEIN_VOLUME, (BYTE)( ( gbLineInVolumeL << 4 ) | gbLineInVolumeR ) );
    vRecord( "temp.raw", _TST_SAMPLE_RATE );
    bWrMReg( _MREG_RM_LINEIN_VOLUME, 0x00 );
    vDisableSineWave();

    wTmp = iCalcFreqStereo( "temp.raw" );
    wLAvg = _TST_SAMPLE_RATE / HIBYTE( wTmp );
    wRAvg = _TST_SAMPLE_RATE / LOBYTE( wTmp );

    vDisplayDebugMessage("LAvg:%u\n", wLAvg );
    vDisplayDebugMessage("RAvg:%u\n", wRAvg );


    if( abs( (int)( gwLineInFrequency - wLAvg ) ) < gbLineInTolerance )
        {
        if( abs( (int)( gwLineInFrequency - wRAvg ) ) < gbLineInTolerance )
            {
            vDisplayStatusMessage( "LineIn Loopback Test: Passed" );
            bRetVal = TRUE;
            }
        else
            {
            vDisplayErrorMessage( "LineIn Loopback Test: Right Channel Failed" );
            }
        }
    else
        {
        vDisplayErrorMessage( "LineIn Loopback Test: Left Channel Failed" );
        bRetVal = FALSE;
        }

    vCheckAutoMode( bRetVal );

    remove("temp.raw");

    return( bRetVal );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTestCDLineInLoopback( void )
	{
    BYTE    bScreenRow = (BYTE)( _STA_WINDOW_POSY + 1 );

	BYTE	bRetVal = FALSE;

    WORD    wLAvg,
            wRAvg,
            wTmp;

    vDisplayConfig();
    vDisplayTitle( "Testing CDLineIn Loopback...." );
    vDisplayOptionMessage( "Please Wait...." );

    vEnableSineWave();
    bWrMReg( _MREG_RM_CDLINEIN_VOLUME, (BYTE)( ( gbCDLineInVolumeL << 4 ) | gbCDLineInVolumeR ) );
    vRecord( "temp.raw", _TST_SAMPLE_RATE );
    bWrMReg( _MREG_RM_CDLINEIN_VOLUME, 0x00 );
    vDisableSineWave();

    wTmp = iCalcFreqStereo( "temp.raw" );
    wLAvg = _TST_SAMPLE_RATE / HIBYTE( wTmp );
    wRAvg = _TST_SAMPLE_RATE / LOBYTE( wTmp );

    vDisplayDebugMessage("LAvg:%u\n", wLAvg );
    vDisplayDebugMessage("RAvg:%u\n", wRAvg );

    if( abs( (int)( gwCDLineInFrequency - wLAvg ) ) < gbCDLineInTolerance )
        {
        if( abs( (int)( gwCDLineInFrequency - wRAvg ) ) < gbCDLineInTolerance )
            {
            vDisplayStatusMessage( "CDLineIn Loopback Test: Passed" );
            bRetVal = TRUE;
            }
        else
            {
            vDisplayErrorMessage( "CDLineIn Loopback Test: Right Channel Failed" );
            }
        }
    else
        {
        vDisplayErrorMessage( "CDLineIn Loopback Test: Left Channel Failed" );
        bRetVal = FALSE;
        }

    vCheckAutoMode( bRetVal );

    remove("temp.raw");

    return( bRetVal );
	}
    
    
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTestMicLoopback( void )
	{
    BYTE    bScreenRow = (BYTE)( _STA_WINDOW_POSY + 1 );

	BYTE	bRetVal = FALSE;

    WORD    wLAvg,
            wRAvg,
            wTmp;

    vDisplayConfig();
    vDisplayTitle( "Testing Mic Loopback...." );
    vDisplayOptionMessage( "Please Wait...." );

    vEnableSineWave();
    bWrMReg( _MREG_RM_MIC_VOLUME, (BYTE)( ( gbMicVolumeL << 4 ) | gbMicVolumeR ) );
    vRecord( "temp.raw", _TST_SAMPLE_RATE );
    bWrMReg( _MREG_RM_MIC_VOLUME, 0x00 );
    vDisableSineWave();

    wTmp = iCalcFreqStereo( "temp.raw" );
    wLAvg = _TST_SAMPLE_RATE / HIBYTE( wTmp );
    wRAvg = _TST_SAMPLE_RATE / LOBYTE( wTmp );

    vDisplayDebugMessage("LAvg:%u\n", wLAvg );
    vDisplayDebugMessage("RAvg:%u\n", wRAvg );

    if( abs( (int)( gwMicFrequency - wLAvg ) ) < gbMicTolerance )
        {
        if( abs( (int)( gwMicFrequency - wRAvg ) ) < gbMicTolerance )
            {
            vDisplayStatusMessage( "Mic Loopback Test: Passed" );
            bRetVal = TRUE;
            }
        else
            {
            vDisplayErrorMessage( "Mic Loopback Test: Right Channel Failed" );
            }
        }
    else
        {
        vDisplayErrorMessage( "Mic Loopback Test: Left Channel Failed" );
        bRetVal = FALSE;
        }

    vCheckAutoMode( bRetVal );

    remove("temp.raw");

    return( bRetVal );
	}
    
    
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTestMicLoopbackOld( void )
	{
    BYTE    bScreenRow = (BYTE)( _STA_WINDOW_POSY + 1 );

	BYTE	bRetVal = FALSE;

    vDisplayConfig(  );
    vDisplayTitle( "Testing Mic Loopback...." );
    vDisplayOptionMessage( "Please Wait...." );

    vEnableSineWave();
    bWrMReg( _MREG_RM_MIC_VOLUME, (BYTE)( ( gbMicVolumeL << 4 ) | gbMicVolumeR ) );
    vRecord( "temp.raw", _TST_SAMPLE_RATE );
    bWrMReg( _MREG_RM_MIC_VOLUME, 0x00 );
    vDisableSineWave();

    if( abs( (int)( gwMicFrequency - ( _TST_SAMPLE_RATE / iCalcFreq( "temp.raw" ) ) ) ) < gbMicTolerance )
        {
        vDisplayStatusMessage( "Mic Loopback Test: Passed" );
        bRetVal = TRUE;
        }
    else
        {
        vDisplayErrorMessage( "Mic Loopback Test: Failed" );
        bRetVal = FALSE;
        }

    vCheckAutoMode( bRetVal );

    remove("temp.raw");

    return( bRetVal );
	}
	
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/******************************************************************************/
BYTE    bTestRAMFIFO( void )
	{
	BYTE    bRetVar = TRUE;

	int     iTmpData;

	iResetDSP(  );

	iEnableExtendedMode(  );

	iWrXReg( 0xB8, 0x05 );

	iWrDSP( 0x00 );

 /* no-op to be sure previous cmd finished */
	iRdDSP(  );


 /* test fifo flags indicate empty */
	if ( ( bGetDSPStatus(  ) & 0x38 ) != 0x18 )
		return ( FALSE );

	for ( iTmpData = 0; iTmpData < 256; iTmpData++ )
		bWrFIFO( ( BYTE ) iTmpData );

 /* test fifo flags indicate full */
	if ( ( bGetDSPStatus(  ) & 0x38 ) != 0x20 )
		return ( FALSE );

	iWrXReg( 0xB8, 0x04 );

	iWrXReg( 0xB8, 0x07 );

 /* no-op to be sure previous cmd finished */
	iWrDSP( 0x00 );
	iRdDSP(  );

	for ( iTmpData = 0; iTmpData < 256; iTmpData++ )
		if ( bRdFIFO(  ) != iTmpData )
			return ( FALSE );

	if ( bGetDSPStatus(  ) & 0x38 != 0x18 )
		return ( FALSE );

	iWrXReg( 0xB8, 0x04 );
	iWrXReg( 0xB8, 0x05 );

	iWrDSP( 0x00 );
	iRdDSP(  );

	for ( iTmpData = 0; iTmpData < 256; iTmpData++ )
		bWrFIFO( ( BYTE ) ( 255 - iTmpData ) );

	if ( bGetDSPStatus(  ) & 0x38 != 0x20 )
		return ( FALSE );

	iWrXReg( 0xB8, 0x04 );
	iWrXReg( 0xB8, 0x06 );
	iWrXReg( 0xB8, 0x07 );

	iWrDSP( 0x00 );
	iRdDSP(  );

	for ( iTmpData = 0; iTmpData < 256; iTmpData++ )
		if ( bRdFIFO(  ) != 255 - iTmpData )
			{
			return ( FALSE );
			}

	return ( TRUE );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE	bTestJoystick( void )
	{
    BYTE    bTimeoutFlag = FALSE,
            bRetVal = TRUE;
			
	BYTE    bTestArray[JOYLEN];

	WORD    wTestIndex;

	char    sTmpString[5];

	BYTE    bJoystickButtonFlags;

	WORD    wJoystickAX,
            wJoystickAY,
            wJoystickBX,
            wJoystickBY;

    WORD    wJoystickAXDeltaMin = 0,
            wJoystickAXDeltaMax = 0,
            wJoystickAYDeltaMin = 0,
            wJoystickAYDeltaMax = 0,
            wJoystickBXDeltaMin = 0,
            wJoystickBXDeltaMax = 0,
            wJoystickBYDeltaMin = 0,
            wJoystickBYDeltaMax = 0;

	WORD    wJoystickAXDelta,
            wJoystickAYDelta,
            wJoystickBXDelta,
            wJoystickBYDelta;

	WORD    wJoystickAXAverage=0,
			wJoystickAYAverage=0,
			wJoystickBXAverage=0,
			wJoystickBYAverage=0;

	BYTE    bFirstPass = TRUE;

    vDisplayConfig();
    vDisplayTitle( "Testing Game Port...." );
    vDisplayOptionMessage( "Press any key to continue...." );

	if ( bCheckLoopBackPlug() == FALSE )
		{
        vDisplayErrorMessage( "Loopback connector not detected." );

        vCheckAutoMode( bRetVal );

		bRetVal = FALSE;
		}
	else
		{	
	    
        vPrintStringXY( 18,  9, "    Game Port #1     ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
        vPrintStringXY( 18, 10, "                     ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
        vPrintStringXY( 18, 11, "   Button 1:         ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
        vPrintStringXY( 18, 12, "   Button 2:         ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
        vPrintStringXY( 18, 13, " Position X:         ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
        vPrintStringXY( 18, 14, " Position Y:         ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );

        vPrintStringXY( 40,  9, "    Game Port #2     ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
        vPrintStringXY( 40, 10, "                     ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
        vPrintStringXY( 40, 11, "   Button 1:         ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
        vPrintStringXY( 40, 12, "   Button 2:         ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
        vPrintStringXY( 40, 13, " Position X:         ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );
        vPrintStringXY( 40, 14, " Position Y:         ", _MNU_TEXT_FGCOLOR, _MNU_TEXT_BGCOLOR );


        if( flgAutoMode )
			vSetEventWait( 0x1E8480 * 3, &bTimeoutFlag );
			
		do
			{
			bJoystickButtonFlags = (BYTE)inp( gwIOJoystick );
	
			if ( bJoystickButtonFlags & 0x10 )
				vPrintStringXY( 31, 11, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
			else
				vPrintStringXY( 31, 11, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
	
	
			if ( bJoystickButtonFlags & 0x20 )
				vPrintStringXY( 31, 12, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
			else
				vPrintStringXY( 31, 12, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
	
	
			if ( bJoystickButtonFlags & 0x40 )
				vPrintStringXY( 53, 11, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
			else
				vPrintStringXY( 53, 11, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
	
	
			if( bJoystickButtonFlags & 0x80 )
				vPrintStringXY( 53, 12, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
			else
				vPrintStringXY( 53, 12, "PASS", _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
	
	
			_asm
				{
				pushf
	
				push    cx
				push    ax
				push    dx
				push    si
	
				cld
	
				cli
	
				mov     dx, gwIOJoystick
				out     dx, al
	
				mov     cx, JOYLEN
	
		_wait:
				in      al, dx
				mov     si, cx
				mov     bTestArray[si], al
	
				loopnz _wait
	
				sti
	
				pop     si
				pop     dx
				pop     ax
				pop     cx
	
				popf
				}
	
			wJoystickAX = 0;
			wJoystickAY = 0;
			wJoystickBX = 0;
			wJoystickBY = 0;
	
			for ( wTestIndex = 0; wTestIndex < JOYLEN; wTestIndex++ )
				{
				if ( bTestArray[wTestIndex] & 0x01 )
					++wJoystickAX;
	
				if ( bTestArray[wTestIndex] & 0x02 )
					++wJoystickAY;
	
				if ( bTestArray[wTestIndex] & 0x04 )
					++wJoystickBX;
	
				if ( bTestArray[wTestIndex] & 0x08 )
					++wJoystickBY;
				}
	
	
			wJoystickAXAverage = ( wJoystickAXAverage + abs( wJoystickAX ) ) >> 1;
			wJoystickAYAverage = ( wJoystickAYAverage + abs( wJoystickAY ) ) >> 1;
			
			wJoystickBXAverage = ( wJoystickBXAverage + abs( wJoystickBX ) ) >> 1;
			wJoystickBYAverage = ( wJoystickBYAverage + abs( wJoystickBY ) ) >> 1;
	
			if ( wJoystickAX < wJoystickAXDeltaMin || bFirstPass )
				wJoystickAXDeltaMin = wJoystickAX;
	
			if ( wJoystickAX > wJoystickAXDeltaMax )
				wJoystickAXDeltaMax = wJoystickAX;
	
	
			if ( wJoystickAY < wJoystickAYDeltaMin || bFirstPass )
				wJoystickAYDeltaMin = wJoystickAY;
	
			if ( wJoystickAY > wJoystickAYDeltaMax )
				wJoystickAYDeltaMax = wJoystickAY;
	
	
	
			if ( wJoystickBX < wJoystickBXDeltaMin || bFirstPass )
				wJoystickBXDeltaMin = wJoystickBX;
	
			if ( wJoystickBX > wJoystickBXDeltaMax )
				wJoystickBXDeltaMax = wJoystickBX;
	
	
	
			if ( wJoystickBY < wJoystickBYDeltaMin || bFirstPass )
				wJoystickBYDeltaMin = wJoystickBY;
	
			if ( wJoystickBY > wJoystickBYDeltaMax )
				wJoystickBYDeltaMax = wJoystickBY;
	
	
			wJoystickAXDelta = (WORD)abs( wJoystickAX - wJoystickAXAverage );
			wJoystickAYDelta = (WORD)abs( wJoystickAY - wJoystickAYAverage );
	
			wJoystickBXDelta = (WORD)abs( wJoystickBX - wJoystickBXAverage );
			wJoystickBYDelta = (WORD)abs( wJoystickBY - wJoystickBYAverage );
	
	
            if( wJoystickAXDelta > gbJoystickTolerance )
				{
				vPrintStringXY( 31, 13, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
				}
			else
				{
				sprintf( sTmpString, "%- 4u", wJoystickAX );
				vPrintStringXY( 31, 13, sTmpString, _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
				}
	
            if( wJoystickAYDelta > gbJoystickTolerance )
				{
				vPrintStringXY( 31, 14, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
				}
			else
				{
				sprintf( sTmpString, "%- 4u", wJoystickAY );
				vPrintStringXY( 31, 14, sTmpString, _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
				}

            if( wJoystickBXDelta > gbJoystickTolerance )
				{
				vPrintStringXY( 53, 13, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
				}
			else
				{
				sprintf( sTmpString, "%- 4u", wJoystickAX );
				vPrintStringXY( 53, 13, sTmpString, _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
				}
				
			
            if( wJoystickBYDelta > gbJoystickTolerance )
				{
				vPrintStringXY( 53, 14, "FAIL", _ERR_TEXT_FGCOLOR, _ERR_TEXT_BGCOLOR );
				}
			else
				{
				sprintf( sTmpString, "%- 4u", wJoystickBY );
				vPrintStringXY( 53, 14, sTmpString, _OPT_TEXT_FGCOLOR, _OPT_TEXT_BGCOLOR );
				}
	
	
			if ( bFirstPass )
				bFirstPass = FALSE;
	
	        if( kbhit() )
	            {
	            bTimeoutFlag = TRUE;
	            getch();
	            }
			}
	        while( bTimeoutFlag == FALSE );
		}        

    if( flgAutoMode )
        {
        vClearEventWait();
        }

    vDelay( _HALF_SECOND );

    return( bRetVal );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE	bTestMPU401( void )
	{
    BYTE	bRetVal = TRUE;

    vDisplayConfig();

    vDisplayTitle( "Testing MPU401 Port...." );
    vDisplayOptionMessage( "Press any key to continue...." );
    
    if ( bCheckLoopBackPlug(  ) == FALSE )
		{
        vDisplayErrorMessage( "Loopback connector not detected." );
        bRetVal = FALSE;
		}
    else
		{
        if ( iResetMPU401(  ) != _ES_MPU401_OK )
			bRetVal = FALSE;
	
		if ( iEnableUartMode(  ) != _ES_MPU401_OK )
			bRetVal = FALSE;
	
		iWrMPU401Data( 0xAA );
		if ( iRdMPU401Data(  ) != 0xAA )
			{
			bRetVal = FALSE;
			}
	
		iWrMPU401Data( 0x55 );
		if ( iRdMPU401Data(  ) != 0x55 )
			{
			bRetVal = FALSE;
			}
	
		iWrMPU401Data( 0x00 );
	
		if ( iRdMPU401Data(  ) != 0x00 )
			{
			bRetVal = FALSE;
			}
	
		iWrMPU401Data( 0xFF );
	
		if ( iRdMPU401Data(  ) != 0xFF )
			{
			bRetVal = FALSE;
			}
	
		if ( iResetMPU401(  ) != _ES_MPU401_OK )
			{
			bRetVal = FALSE;
			}

		if ( bRetVal == FALSE )
			{
            vDisplayErrorMessage( "MPU401 Test: Failed" );
	        bRetVal = FALSE;
			}
		else
			{
            vDisplayStatusMessage( "MPU401 Test: Passed" );
			}
		}
		
    vCheckAutoMode( bRetVal );

	return( bRetVal );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int iCalcFreq( const char * _lpFileName )
    {
    int     iFileHandle;

    int     iWord1 = 0,
            iWord2 = 0,
            iAvg = 0,
            iCount = 0;

    iFileHandle = open( _lpFileName, O_BINARY | O_RDONLY );

    do
        {
        if( iWord1 < 0 && iWord2 > 0 )
            {
            iAvg = ( iAvg + iCount ) >> 1;
            iCount=0;
            }
        else
            {
            if( iWord1 == 0 && iWord2 > 0 )
                {
                iAvg = ( iAvg + iCount ) >> 1;
                iCount=0;
                }
            else
                {
                if( iWord1 < 0 && iWord2 == 0 )
                    {

                    iAvg = ( iAvg + iCount ) >> 1;
                    iCount=0;

                    }
                }
            }
        ++iCount;
        iWord2 = iWord1;
        iWord1 = 0;
        read( iFileHandle, &iWord1, 1 );
        }
    while( !eof( iFileHandle ) );

    close( iFileHandle );

    if( iAvg == 0 )
        iAvg = 1;

    return( iAvg );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int iCalcFreqStereo( const char * _lpFileName )
    {
    int     iFileHandle;

    int     iLWord1 = 0x80,
            iLWord2 = 0x80,
            iRWord1 = 0x80,
            iRWord2 = 0x80,
            iLAvg = 0,
            iRAvg = 0,
            iLCount = 0,
            iRCount = 0;


    iFileHandle = open( _lpFileName, O_BINARY | O_RDONLY );

    do
        {
        if( iLWord1 < 128 && iLWord2 > 128 )
            {
            iLAvg = ( iLAvg + iLCount ) >> 1;
            iLCount=0;
            }
        else
            {
            if( iLWord1 == 0 && iLWord2 > 128 )
                {
                iLAvg = ( iLAvg + iLCount ) >> 1;
                iLCount=0;
                }
            else
                {
                if( iLWord1 < 128 && iLWord2 == 128 )
                    {

                    iLAvg = ( iLAvg + iLCount ) >> 1;
                    iLCount=0;

                    }
                }
            }

        if( iRWord1 < 128 && iRWord2 > 128 )
            {
            iRAvg = ( iRAvg + iRCount ) >> 1;
            iRCount=0;
            }
        else
            {
            if( iRWord1 == 0 && iRWord2 > 128 )
                {
                iRAvg = ( iRAvg + iRCount ) >> 1;
                iRCount=0;
                }
            else
                {
                if( iRWord1 < 128 && iRWord2 == 128 )
                    {

                    iRAvg = ( iRAvg + iRCount ) >> 1;
                    iRCount=0;

                    }
                }
            }
        ++iLCount;
        ++iRCount;

        iLWord2 = iLWord1;
        iRWord2 = iRWord1;

        iLWord1 = 0x80;
        iRWord1 = 0x80;

        read( iFileHandle, &iLWord1, 1 );
        read( iFileHandle, &iRWord1, 1 );
        }
    while( !eof( iFileHandle ) );

    close( iFileHandle );


    if( iLAvg == 0 )
        iLAvg = 1;

    if( iRAvg == 0 )
        iRAvg = 1;

    vDisplayDebugMessage("L Ch:%u\n", iLAvg );
    vDisplayDebugMessage("R Ch:%u\n", iRAvg );

    return( (WORD)( (iLAvg << 8 ) | iRAvg ) );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bCheckLoopBackPlug( void )
	{
	BYTE    bRetVal = TRUE;

    outp( gwIOJoystick, 0xFF );

    vDelay( _4TH_SECOND );

	if ( inp( gwIOJoystick ) != 0x00 )
		bRetVal = FALSE;

	return ( bRetVal );
	}


